﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved

function SetCurrentEventData(name,value) {
	SetEventData(m_lEventID,name,value);
}

function SetEventData(sEventID,name,value) {
	lEventID = GetEventRefNumFromName(sEventID);
	m_arrEvents[String(lEventID)].arrPersist[name] = value;
}

function GetCurrentEventData(name) {
	return GetEventData(m_lEventID,name);
}

function GetEventData(sEventID,name) {
	lEventID = GetEventRefNumFromName(sEventID);
	return convertNull(m_arrEvents[String(lEventID)].arrPersist[name]);
}

function DeleteCurrentEventData(name) {
	return DeleteEventData(m_lEventID,name);
}

function DeleteEventData(sEventID,name) {
	lEventID = GetEventRefNumFromName(sEventID);
	m_arrEvents[String(lEventID)].arrPersist[name] = null;
}

function DeleteCurrentEventAllData() {
	DeleteEventAllData(m_lEventID);
}

function DeleteEventAllData(sEventID) {
	lEventID = GetEventRefNumFromName(sEventID);
	m_arrEvents[String(lEventID)].arrPersist = new Array();
}

function PersistEventAllDataForElement(sEventID,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	lEventID = GetEventRefNumFromName(sEventID);
	var arrElements = windowtarget.document.body.getElementsByTagName("INPUT");
	var foid;
	for (var i=0;i<arrElements.length;i++){
		foid = GetFrameObjectNameFromDOM(arrElements[i]);
		if (foid != null) {
			if (arrElements[i].type=="radio" || arrElements[i].type=="checkbox"){
				SetEventData(lEventID,foid,arrElements[i].checked);			
			}else if (arrElements[i].type=="text" || arrElements[i].type==""){
				SetEventData(lEventID,foid,arrElements[i].value);			
			}	
		}	
	}	
	
	arrElements = windowtarget.document.body.getElementsByTagName("TEXTAREA");
	for (var i=0;i<arrElements.length;i++){
		foid = GetFrameObjectNameFromDOM(arrElements[i]);
		if (foid != null) {
			SetEventData(lEventID,foid,arrElements[i].value);			
		}	
	}	
	
	for (var i in windowtarget.arrContent) {
		var obj = windowtarget.arrContent[i];
		if (obj != null) {
			if (obj.TYPE == "multistateimage") {
				SetEventData(lEventID,obj.NAME,obj.CURRENTSTATE);
			} else if (obj.TYPE == "multistatebutton") {
				SetEventData(lEventID,obj.NAME,obj.CURRENTSTATE);
			}
		}	
	}
}

function PersistCurrentEventAllData(windowtarget){
	PersistEventAllDataForElement(m_lEventID,windowtarget);	
}

function RetrieveEventAllDataForElement(sEventID,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	lEventID = GetEventRefNumFromName(sEventID);
	var arrElements = windowtarget.document.body.getElementsByTagName("INPUT");
	var foid;
	for (var i=0;i<arrElements.length;i++){
		foid = GetFrameObjectNameFromDOM(arrElements[i]);
		if (foid != null) {
			if (arrElements[i].type=="radio" || arrElements[i].type=="checkbox"){
				if (GetEventData(lEventID,foid) != "") {
					arrElements[i].checked = GetEventData(lEventID,foid);			
				}	
			}else if (arrElements[i].type=="text" || arrElements[i].type==""){
				if (GetEventData(lEventID,foid) != "") {
					arrElements[i].value = GetEventData(lEventID,foid);			
				}	
			}	
		}	
	}	

	arrElements = windowtarget.document.body.getElementsByTagName("TEXTAREA");
	for (var i=0;i<arrElements.length;i++){
		foid = GetFrameObjectNameFromDOM(arrElements[i]);
		if (foid != null) {
			if (GetEventData(lEventID,foid) != "") {
				arrElements[i].value = GetEventData(lEventID,foid);			
			}	
		}	
	}	

	for (var i in windowtarget.arrContent) {
		var obj = windowtarget.arrContent[i];
		if (obj != null) {
			if (obj.TYPE == "multistateimage") {
				SetMultistateImageState(obj.NAME,GetEventData(lEventID,obj.NAME),windowtarget);
			} else if (obj.TYPE == "multistatebutton") {
				SetButtonState(obj.NAME,GetEventData(lEventID,obj.NAME),windowtarget);
			}
		}
	}

	ShowCorrectOnFinal(windowtarget);	
}

function RetrieveCurrentEventAllData(windowtarget){
	RetrieveEventAllDataForElement(m_lEventID,windowtarget);	
}		

function GetEventAllDefaultDataForElement(sEventID,windowtarget){
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	lEventID = GetEventRefNumFromName(sEventID);
	var curEvent = m_arrEvents[String(lEventID)];
	if (curEvent.arrContent == null){
		return;
	}	
	var arrElements = windowtarget.document.body.getElementsByTagName("INPUT");
	var foid;
	for (var i=0;i<arrElements.length;i++){
		foid = GetFrameObjectNameFromDOM(arrElements[i]);
		if (foid != null) {
			if (arrElements[i].type=="radio" || arrElements[i].type=="checkbox"){
				if (convertNull(curEvent.arrContent[foid].DEFAULT).toLowerCase()=="true"){
					arrElements[i].checked = true;		
				}else{
					arrElements[i].checked = false;		
				}
			}else if (arrElements[i].type=="text" || arrElements[i].type==""){
				if (convertNull(curEvent.arrContent[foid].DEFAULT) != ""){
					arrElements[i].value = convertNull(curEvent.arrContent[foid].DEFAULT);		
				}
			}	
		}	
	}

	arrElements = windowtarget.document.body.getElementsByTagName("TEXTAREA");
	for (var i=0;i<arrElements.length;i++){
		foid = GetFrameObjectNameFromDOM(arrElements[i]);
		if (foid != null) {
			if (convertNull(curEvent.arrContent[foid].DEFAULT) != ""){
				arrElements[i].value = convertNull(curEvent.arrContent[foid].DEFAULT);		
			}	
		}	
	}
	
	for (var i in windowtarget.arrContent) {
		var obj = windowtarget.arrContent[i];
		if (obj != null) {
			if (obj.TYPE == "multistateimage") {
				SetMultistateImageState(obj.NAME,obj.DEFAULTSTATE,windowtarget);
			} else if (obj.TYPE == "multistatebutton") {
				SetButtonState(obj.NAME,obj.DEFAULTSTATE,windowtarget);
			}
		}
	}	
	
}

function GetCurrentEventAllDefaultData(windowtarget){
	GetEventAllDefaultDataForElement(m_lEventID,windowtarget);	
}

function ResetEntireCourse(){
	for (var obj in m_arrEvents){
		ResetEvent(obj);
	}
}

function ResetEvent(sID){
	var lEventID = GetEventRefNumFromName(sID);
	DeleteEventAllData(lEventID);
	m_arrEvents[String(lEventID)].VISITED = "f";
	m_arrEvents[String(lEventID)].arrContent = new Array();
	m_arrEvents[String(lEventID)].LASTFRAMEID = 1;
}		
