﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved

var m_status;
var m_allComplete;

function TrackCompletionStatus(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete,windowtarget) {
	return TrackCompletionStatusForEvent(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete,"btn",parent.engine.m_lEventID,windowtarget);
}

function TrackCompletionStatusForEvent(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete,sNavLinkPrefix,sEventID,windowtarget) {
	if (!m_bUseCompletionStatus) return;

	// Get number of Nav Links on event
	var status;
	var bAllComplete = true;
	var colNodes;
	lEventID = GetEventRefNumFromName(sEventID);
	colNodes = findNavLinks(1,lEventID);
	
	var numMenuItems = colNodes.length;
		
	for (var cnt=1; cnt<=numMenuItems;cnt++) {
		status = CP.GetCompletionStatusForEvent(lEventID, sNavLinkPrefix + '_' + cnt);
		if (status == 'i') {
			bAllComplete = false;
			CP.SetVisibility(sBulletStartedPrefix + '_' + cnt,'visible',windowtarget);
		} else if (status == 'c') {
			CP.SetVisibility(sBulletCompletePrefix + '_' + cnt,'visible',windowtarget);
		} else if (status == 'n') {
			bAllComplete = false;
		}
	}

	if (bAllComplete) {
		SetVisibility(sFrameListObjectNameComplete,'visible',windowtarget);
	}
	
	return bAllComplete;
}

// Really should return if all events under this event have never been visited, partially been visited, or all have been visited
function IsEventComplete(sEventID,sNavLinkPrefix) {
	var status;
	var bAllComplete = true;
	var colNodes;
	lEventID = GetEventRefNumFromName(sEventID);
	colNodes = findNavLinks(1,lEventID);
	
	var numMenuItems = colNodes.length;

	for (var cnt=1; cnt<=numMenuItems;cnt++) {
		status = CP.GetCompletionStatusForEvent(lEventID, sNavLinkPrefix + '_' + cnt);
		if (status == 'i') {
			bAllComplete = false;
		} else if (status == 'c') {
		} else if (status == 'n') {
			bAllComplete = false;
		}
	}

	if (bAllComplete) {
		return true;
	} else {
		return false;
	}
}

function IsCurrentEventComplete(sNavLinkPrefix) {
	return IsEventComplete(m_lEventID,sNavLinkPrefix);
}

function TrackCompletionStatusMSI(sBulletPrefix,sFrameListObjectNameComplete,windowtarget) {
	TrackCompletionStatusForEventMSI(sBulletPrefix,sFrameListObjectNameComplete,"btn",parent.engine.m_lEventID,windowtarget);
}

function TrackCompletionStatusForEventMSI(sBulletPrefix,sFrameListObjectNameComplete,sNavLinkPrefix,sEventID,windowtarget) {
	if (!m_bUseCompletionStatus) return;

	// Get number of Nav Links on event
	var status;
	var bAllComplete = true;
	var colNodes;
	lEventID = GetEventRefNumFromName(sEventID);
	colNodes = findNavLinks(1,lEventID);
	
	var numMenuItems = colNodes.length;
		
	for (var cnt=1; cnt<=numMenuItems;cnt++) {
		status = CP.GetCompletionStatusForEvent(lEventID, sNavLinkPrefix + '_' + cnt);
		if (status == 'i') {
			bAllComplete = false;
			// Need to get the content name not the FLOName
			CP.SetMultistateImageState(sBulletPrefix + '_' + cnt,'state 2',windowtarget);
		} else if (status == 'c') {
			// Need to get the content name not the FLOName
			CP.SetMultistateImageState(sBulletPrefix + '_' + cnt,'state 3',windowtarget);
		} else if (status == 'n') {
			bAllComplete = false;
		}
	}

	if (bAllComplete) {
		SetVisibility(sFrameListObjectNameComplete,'visible',windowtarget);
	}
}


function GetCompletionStatus(sNavLinkName) {
	return GetCompletionStatusForEvent(parent.engine.m_lEventID,sNavLinkName);
}

function GetCompletionStatusForEvent(sEventID,sNavLinkName) {
	if (!m_bUseCompletionStatus) return "n";
	
	m_status = "n";
	m_allComplete = true;
	
	lEventID = GetEventRefNumFromName(sEventID);
	var objNav = getNavForNavLinkForEvent(lEventID,sNavLinkName);
	if (objNav != null) {
		traverseNavLinksForStatus(2,Number(objNav.ID));
	}else{
		return "";
	}
	if (m_status == "n") {
		return "n";
	} else if (m_status == "i" && m_allComplete == false) {
		return "i";
	} else {
		return "c";
	}
}

function traverseNavLinksForStatus(nOriginType,lOriginID) {
	var colOrgNodes;
	var colDstNodes;
	var nDstType;
	var lDstID;
	var objEvent;
	colOrgNodes = findNavLinks(nOriginType,lOriginID);

	for (var i=0; i<colOrgNodes.length; i++) {
		nDstType = colOrgNodes[i].DSTTYPE;
		lDstID = colOrgNodes[i].DSTID;
		if (nDstType == 1) {
			objEvent = findEvent(lDstID);
			if (objEvent.VISITED != null) {
                if (objEvent.VISITED.toLowerCase() == "ignore") {
                } else {
                    if (objEvent.VISITED.toLowerCase() == "true") {
                        m_status = "i";
                    } else {
                        m_allComplete = false;
                    }
                }                
			} else {
				m_allComplete = false;
			}
		}

		colDstNodes = findNavLinks(nDstType,lDstID);
		if (colDstNodes.length != 0) {
			traverseNavLinksForStatus(nDstType, lDstID);
		}
	}
}

// New Function
function TrackCompletionStatusForFrames(sFrameObjectPrefix,windowtarget) {
	var persist = true;
	if (m_arrEvents[String(m_lEventID)].PERSIST != null) {
		if (m_arrEvents[String(m_lEventID)].PERSIST != "") {
			persist = m_arrEvents[String(m_lEventID)].PERSIST;
		}else{
			persist = m_bPersistData;
		}	
	}else{
		persist = m_bPersistData;
	}	
	if (persist == false) {
	   DeleteCurrentEventAllData();
	}
	
	ShowBulletsCompleteForFrames(GetTotalFrames()-1,sFrameObjectPrefix,windowtarget);
}

// New Function
function SetBulletCompleteForFrames(numBullets,sFrameObjectPrefix,index,windowtarget) {
	MarkBulletCompleteForFrames(sFrameObjectPrefix,index);

	ShowBulletsCompleteForFrames(numBullets,sFrameObjectPrefix,windowtarget);
}

// Don't expose
function MarkBulletCompleteForFrames(sFrameObjectPrefix,index) {
   SetCurrentEventData(sFrameObjectPrefix + "_" + index,"true");
}

// Don't expose
function ShowBulletsCompleteForFrames(numBullets,sFrameObjectPrefix,windowtarget) {
   var data;
   
   for (var i=1; i<=numBullets; i++) {
   	data = GetCurrentEventData(sFrameObjectPrefix + "_" + i);
      if (data == "true") {
         SetVisibility(sFrameObjectPrefix + "_" + i,"visible",windowtarget);
      } else {
         SetVisibility(sFrameObjectPrefix + "_" + i,"hidden",windowtarget);
      }
   }
}

function IsEventVisited(sEventID) {
	lEventID = GetEventRefNumFromName(sEventID);
	if (m_arrEvents[String(lEventID)].VISITED != null) {
		if (m_arrEvents[String(lEventID)].VISITED.toLowerCase() == "true" ){
			return true;
		} else {
			return false;
		}		
	} else {
		return false;
	}	
}

function MarkCurrentEventVisited(sVisited) {
	MarkEventVisited(m_lEventID,sVisited);
}

function MarkEventVisited(sEventID,sVisited) {
	lEventID = GetEventRefNumFromName(sEventID);
	m_arrEvents[String(lEventID)].VISITED = sVisited.toLowerCase();
	if (m_sTracking=="scorm" || m_sTracking=="HACP"){
		lmsCommitCompletionStatus();
	}		  
	MarkEventCompletionStatus(lEventID);
}

function MarkEventCompletionStatus(sEventID){
	lEventID = GetEventRefNumFromName(sEventID);
	MarkItemCompletion(m_arrEvents[lEventID]);
}

function MarkItemCompletion(oItem){
	var sStatus = "c";
	if (oItem.completionStatus != "c"){
		if (oItem.children.length > 0){
			for (var i=0;i<oItem.children.length;i++){
				if (oItem.children[i].completionStatus == "" || oItem.children[i].completionStatus == "n" || oItem.children[i].completionStatus == "i"){
					if (oItem.children[i].VISITED != "Ignore"){
						sStatus = "i";
						break;
					}	
				}	
			}
			if (oItem.arrFrames!=null){
				if (oItem.VISITED == "false" || oItem.VISITED == null){
					sStatus = "i";
				}	
			}
		}else{
			sStatus = "c";

		}
		oItem.setCompletionStatus(sStatus);

	}
	MarkTreeItemCompletion(oItem,sStatus);
	if (oItem.parent != null){
		checkSiblings(oItem);	
	}	
}		

function checkSiblings(oItem){
	var oParent = oItem.parent;
	var sStatus = "c";
	for (var i=0;i<oParent.children.length;i++){
		if (oParent.children[i].completionStatus == "" || oParent.children[i].completionStatus == "n" || oParent.children[i].completionStatus == "i"){
			if (oParent.children[i].VISITED != "Ignore"){	
				sStatus = "i";
				break;
			}	
		}	
	}
	if (oParent.arrFrames!=null){
		if (oParent.VISITED == "false" || oParent.VISITED == null){
			sStatus = "i";
		}	
	}	
	oParent.setCompletionStatus(sStatus);
	
	MarkTreeItemCompletion(oParent,sStatus);
	MarkItemCompletion(oParent);
}

function MarkTreeItemCompletion(oItem,sStatus){
	if (CP.m_bUsesCourseTree == "true"){
		for (var oTree in m_arrTrees){
			var oTreeNode;
			if (oItem.arrFrames!=null){
				oTreeNode = m_arrTreeItems[m_arrTrees[oTree].id + "_Event_" + oItem.ID];
			}else{
				oTreeNode = m_arrTreeItems[m_arrTrees[oTree].id + "_Nav_" + oItem.ID];						
			}	
			if (oTreeNode != null){
				oTreeNode.setCompletionStatus(sStatus);
			}
		}			
	}		
}		


function MarkCurrentEventAndChildrenVisited(sVisited) {
	markNodeAndChildrenVisited(1,m_lEventID,sVisited);
	MarkEventVisited(m_lEventID,sVisited);
}

function MarkEventAndChildrenVisited(sEventID,sVisited) {
	lEventID = GetEventRefNumFromName(sEventID);
	markNodeAndChildrenVisited(1,lEventID,sVisited);
	MarkEventVisited(lEventID,sVisited);
}

function MarkNavLinkNameAndChildrenVisited(sNavLinkName,sVisited) {
	var objNav = getNavForNavLink(sNavLinkName);
	var objNavLink;
	var lDstID;
	if (objNav != null) {
		objNavLink = findNavLink(2,objNav.ID);
		lDstID = objNavLink.DSTID;		
		MarkNavLinkAndChildrenVisited(lDstID,sVisited);
	} else {
		alert("Error! Couldn't find NavLink with name " + sNavLinkName);
	}
}

function MarkNavLinkAndChildrenVisited(lNavLinkID,sVisited) {
	markNodeAndChildrenVisited(2,lNavLinkID,sVisited);
}

function markNodeAndChildrenVisited(nType,lID,sVisited) {
	var colOrgNodes;
	var colDstNodes;
	var nDstType;
	var lDstID;

	colOrgNodes = findNavLinks(nType,lID);
	//MarkEventVisited(lID,sVisited);
	for (var i=0; i<colOrgNodes.length; i++) {
		nDstType = colOrgNodes[i].DSTTYPE;
		lDstID = colOrgNodes[i].DSTID;

		colDstNodes = findNavLinks(nDstType,lDstID);
		if (colDstNodes.length == 0) {
			if (nDstType == 1) {
				MarkEventVisited(lDstID,sVisited);
			}
		} else {
			if (nDstType == 1) {
				MarkEventVisited(lDstID,sVisited);
			}

			markNodeAndChildrenVisited(nDstType,lDstID,sVisited);
		}
	}

}
