﻿//---------- Event Navigation -----------//
function GotoEvent(lEventID) {
	new CSCOStructure().gotoEvent(lEventID);
}

function GotoNextEvent() {
	new CEvent().gotoNextEvent();
}

function GotoPreviousEvent() {
	new CEvent().gotoPreviousEvent();
}

function GotoParentEvent() {
	new CEvent().gotoParentEvent();
}

function ReloadEvent() {
	new CEvent().reloadEvent();
}

function GotoFirstEvent() {
	new CSCOStructure().gotoFirstEvent();
}

function GotoChildEvent(obj) {
	new CEvent(obj).gotoChildEvent();
}

function GotoCurrentEventChildAndFrame(lFrameID) {
	var oEvent = new CEvent();
	oEvent.gotoChildEventAndFrame(lFrameID);
}

function GotoChildNav(sNavLinkName) {
	var oSCOst = new CSCOStructure(sNavLinkName);
	oSCOst.gotoChildNav();
}

function GotoChildNavWithEventID(lEventID, sNavLinkName) {
	var oSCOst = new CSCOStructure(sNavLinkName);
	oSCOst.gotoChildNavWithEventID(lEventID);
}

function GotoChildNavAndFrameWithEventID(lEventID, sNavLinkName, lFrameID) {
	var oSCOst = new CSCOStructure(sNavLinkName);
	oSCOst.gotoChildNavAndFrameWithEventID(lEventID, lFrameID);
}

function GotoNext() {
	new CEvent().gotoNext();
}

function GotoPrevious() {
	new CEvent().gotoPrevious();
}

function GotoEventAndFrame(lEventID, lFrameID) {
	new CSCOStructure().gotoEventAndFrame(lEventID, lFrameID);
}

function GotoEventWithBookmarkAnchor(lEventID, sBMAnchor) {
	new CSCOStructure().gotoEventWithBookmarkAnchor(lEventID, sBMAnchor);
}

// new
function GotoNextChildNavFirstSibling(lEventID) {
	new CEvent(lEventID).gotoNextChildNavFirstSibling();
}

function GotoPreviousChildNavLastSibling(lEventID) {
	new CEvent(lEventID).gotoPreviousChildNavLastSibling();
}

//---------- Frame Navigation -----------//
function GotoFrame(lFrameID) {
	new CEvent().gotoFrame(lFrameID);
}

function GotoFirstFrame() {
	new CEvent().gotoFirstFrame();
}

function GotoNextFrame() {
	return new CEvent().gotoNextFrame();
}

function GotoPreviousFrame() {
	return new CEvent().gotoPreviousFrame();
}

function GotoLastFrame() {
	new CEvent().gotoLastFrame();
}

function JumpToOptionFrame(sGroupName, windowtarget) {
	var oQuest	= new CQuestion(windowtarget);
	oQuest.jumpToOptionFrame(sGroupName);
}

function GotoFrameWithBookmarkAnchor(lFrameID, sBMAnchor) {
	new CEvent().gotoFrameWithBookmarkAnchor(lFrameID, sBMAnchor)
}

// GotoNext() and GotoPrevious() functions are same as Event Navigation functions
//---------- Event Layer Navigation -----------//
function GotoLayer(sLayerName) {
	new CEvent().gotoLayer(sLayerName);
}

function GotoNextLayer() {
	new CEvent().gotoNextLayer();
}

function GotoPreviousLayer() {
	new CEvent().gotoPreviousLayer();
}

//---------- Event History Navigation -----------//
function GotoHistoryNext() {
	new CSCOStructure().gotoHistoryNext();
}

function GotoHistoryPrevious() {
	new CSCOStructure().gotoHistoryPrevious();
}

//---------- Auto Advance Navigation -----------//
function AutoAdvance(sfunctionName, timeout) {
	new CAnimate().autoAdvance(sfunctionName, timeout);
}

function AutoAdvanceGotoEvent(lEventID,timeout) {
	new CAnimate().autoAdvanceGotoEvent(lEventID,timeout);
}

function AutoAdvanceGotoEventAndFrame(lEventID,lFrameID,timeout) {
	new CAnimate().autoAdvanceGotoEventAndFrame(lEventID,lFrameID,timeout);
}

function AutoAdvanceGotoNextEvent(timeout) {
	new CAnimate().autoAdvanceGotoNextEvent(timeout);
}

function AutoAdvanceGotoPreviousEvent(timeout) {
	new CAnimate().autoAdvanceGotoPreviousEvent(timeout);
}

function AutoAdvanceGotoNextFrame(timeout) {
	new CAnimate().autoAdvanceGotoNextFrame(timeout);
}

function AutoAdvanceGotoPreviousFrame(timeout) {
	new CAnimate().autoAdvanceGotoPreviousFrame(timeout);
}

//---------- Supporting Navigation Functions -----------//
function GetEventID() {
	return new CEvent().getRefID();
}

function GetEventRefNumFromName(sEventName) {
	var oEvent = new CEvent(sEventName);
	return oEvent.getRefID();
}

function GetCurrentEventParentID() {
	return oEvent.getParentEventID();
}

function GetParentEventID(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getParentEventID();
}

function GetParentEventNameFromID(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getParentEventName();
}

function GetCurrentEventParentNavID() {
	return new CEvent().getParentID();
}

function GetCurrentEventParentNavName() {
	return new CEvent().getParentName();
}

function GetCurrentEventParentNavAlias() {
	return new CEvent().getParentAliasName();
}

function GetFirstEvent() {
	return new CSCOStructure().getFirstEvent();
}

function GetNextEventID() {
	return new CEvent().getNextEventID();
}

function GetNextEventName() {
	return new CEvent().getNextEventName();
}

function GetPreviousEventID() {
	return new CEvent().getPreviousEventID();
}

function GetPreviousEventName() {
	return new CEvent().getPreviousEventName();
}

function GetEventFirstChildNavID(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getFirstChildID();
}

function GetEventFirstChildNavName(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getFirstChildName();
}

function GetEventChildrenID(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getChildrenID();
}

function GetEventChildrenName(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getChildrenName();
}

function GetEventChildrenIDTokens(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getChildrenIDTokens();
}

function GetEventChildrenNameTokens(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getChildrenNameTokens();
}

function hasChildren(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.hasChildren();
}

function GetCurrentHistoryIndex() {
	return new CSCOStructure().getCurrentHistoryIndex();
}

function GetPreviousHistoryEventID() {
	return new CSCOStructure().getPreviousHistoryEventID();
}

function GetNextHistoryEventID() {
	return new CSCOStructure().getNextHistoryEventID();
}

function GetFrameIndex() {
	return new CEvent().getCurrentFrameID();
}

function GetFrameIndexFromNameForCurrentEvent(sFrameName) {
	return new CEvent().getFrame(sFrameName).getIndex();
}

function GetFrameIndexFromName(lEventID, sFrameName) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getFrame(sFrameName).getIndex();
}

function GetTotalFrames() {
	return new CEvent().getTotalFrames();
}

// new
function GetChildIDForEventWithIndex(lEventID, nIdx) {
	return new CEvent(lEventID).getChildIDWithIndex(nIdx);
}

function GetParentIndexForNav(lNavID) {
	return new CSCOStructure(lNavID).getParentIndex();
}

function AtBeginningOfSCO() {
	return new CSCOStructure().atBeginningOfSCO();
}

function AtEndOfSCO() {
	return new CSCOStructure().atEndOfSCO();
}

function GetChildrenIDForNavLink(lNavID) {
	return new CSCOStructure(lNavID).getChildrenID();
}

function GetChildrenNameForNavLink(lNavID) {
	return new CSCOStructure(lNavID).getChildrenName();
}

function GetChildrenIDTokensForNavLink(lNavID) {
	return new CSCOStructure(lNavID).getChildrenIDTokens();
}

function GetChildrenNameTokensForNavLink(lNavID) {
	return new CSCOStructure(lNavID).getChildrenNameTokens();
}

function GetTotalChildrenForNavLink(lNavID) {
	return new CSCOStructure(lNavID).getTotalChildren();
}

function GetChildIDForNavWithIndex(lNavID, nIdx) {
	return new CSCOStructure(lNavID).getChildIDWithIndex(nIdx);
}

function GetChildNameForNavWithIndex(lNavID, nIdx) {
	return new CSCOStructure(lNavID).getChildNameWithIndex(nIdx);
}
// new - till here

//---------- Open/Close Window Functions -----------//
function OpenWindow(url, windowNumber, windowName, replace, left, top, width, height, resizable, scrollbars, toolbar, menubar, locationbar, statusbar, bForceRelative) {
	return objUtil.openWindow(url,windowNumber,windowName,replace,left,top,width,height,resizable,scrollbars,toolbar,menubar,locationbar,statusbar,bForceRelative);
}

function OpenNewWindowAndCenter(url, windowNumber, width, height, bCenterTop, resizable, scrollbars, toolbar, menubar, locationbar, statusbar, bForceRelative) {
	return objUtil.openNewWindowAndCenter(url,windowNumber,width,height,bCenterTop,resizable,scrollbars,toolbar,menubar,locationbar,statusbar,bForceRelative);
}

function OpenPersistentWindowAndCenter(url, windowNumber, width, height, bCenterTop, resizable, scrollbars, toolbar, menubar, locationbar, statusbar, bForceRelative) {
	return objUtil.openPersistentWindowAndCenter(url,windowNumber,width,height,bCenterTop,resizable,scrollbars,toolbar,menubar,locationbar,statusbar,bForceRelative);
}

function OpenReusableWindowAndCenter(url, windowNumber, width, height, bCenterTop, resizable, scrollbars, toolbar, menubar, locationbar, statusbar, bForceRelative) {
	return objUtil.openReusableWindowAndCenter(url,windowNumber,width,height,bCenterTop,resizable,scrollbars,toolbar,menubar,locationbar,statusbar,bForceRelative);
}

function OpenWindowAndCenter(url, windowNumber, windowName, replace, width, height, bCenterTop, resizable, scrollbars, toolbar, menubar, locationbar, statusbar, bForceRelative) {
	return objUtil.openWindowAndCenter(url,windowNumber,windowName,replace,width,height,bCenterTop,resizable,scrollbars,toolbar,menubar,locationbar,statusbar,bForceRelative);
}

function OpenWindowFullScreen(url, bForceRelative) {
	return objUtil.openWindowFullScreen(url,bForceRelative);
}

function OpenModalWindow(url,xPos,yPos,width,height,center,dialogHide,edge,help,resizable,scroll,status,unadorned,bForceRelative) {
	return objUtil.openModalWindow(url,xPos,yPos,width,height,center,dialogHide,edge,help,resizable,scroll,status,unadorned,bForceRelative);
}

function OpenModalessWindow(url,xPos,yPos,width,height,center,dialogHide,edge,help,resizable,scroll,status,unadorned,bForceRelative) {
	return objUtil.openModalessWindow(url,xPos,yPos,width,height,center,dialogHide,edge,help,resizable,scroll,status,unadorned,bForceRelative);
}

function LaunchEvent(lEventID, windowNumber, width, height, bCenterTop, resizable, scrollbars, toolbar, menubar, locationbar, statusbar) {
	var oEvent = new CEvent(lEventID);
	oEvent.launchEvent(windowNumber,width,height,bCenterTop,resizable,scrollbars,toolbar,menubar,locationbar,statusbar);
}

function LaunchSCO(sSCOID, windowNumber, width, height, bCenterTop, resizable, scrollbars, toolbar, menubar, locationbar, statusbar) {
	objSCO.launchSCO(sSCOID,windowNumber,width,height,bCenterTop,resizable,scrollbars,toolbar,menubar,locationbar,statusbar);
}

function GetURLForEvent(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getURL();
}

function GetURLForEventAndFrame(lEventID, nFrameID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getURLForFrame(nFrameID);
}

function GetURLForSCO(sSCOID) {
	var oSCO = new CSCO(sSCOID);
	return oSCO.getURL();
}

function GetURLForSCOAndEvent(sSCOID, lEventID) {
	var oSCO = new CSCO(sSCOID);
	return oSCO.getURLForEvent(lEventID);
}

function GetURLForSCOAndEventAndFrame(sSCOID, lEventID, lFrameID) {
	var oSCO = new CSCO(sSCOID);
	return oSCO.getURLForEventAndFrame(lEventID,lFrameID);
}

function ExitSCO() {
	objSCO.exitSCO();
}

//---------- Question Functions -----------//
function QuestionEvalOption(windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.questionEvalOption();
}

function QuestionEvalOptionAndJump(windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	oQuest.questionEvalOptionAndJump();
}

function EvaluateOption(sGroupName, nNumTries, sAssessmentID, sQuestionID, sQType, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.evaluateOption(sGroupName,nNumTries,sAssessmentID,sQuestionID,sQType);
}

function QuestionEvalEditbox(windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.questionEvalEditbox();
}

function QuestionEvalEditboxAndJump(windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	oQuest.questionEvalEditboxAndJump();
}

function EvaluateEditbox(sGroupName, nNumTries, sAssessmentID, sQuestionID, sQType, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.evaluateEditbox(sGroupName,nNumTries,sAssessmentID,sQuestionID,sQType);
}

function QuestionEvalCheckBox(windowtarget, bPartiallyCorrect) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.questionEvalCheckBox(bPartiallyCorrect);
}

function QuestionEvalCheckBoxAndJump(windowtarget, bPartiallyCorrect) {
	var oQuest = new CQuestion(null, windowtarget);
	oQuest.questionEvalCheckBoxAndJump(bPartiallyCorrect);	
}

function EvaluateCheckBox(sGroupName, nNumTries, sAssessmentID, sQuestionID, sQType, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.evaluateCheckBox(sGroupName,nNumTries,sAssessmentID,sQuestionID,sQType);
}

//---------- Supporting Question Functions -----------//
function ResultsFromEvaluateOption(sGroupName, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.resultsFromEvaluateOption(sGroupName);
}

function ResultsFromEvaluateEditbox(sGroupName, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.resultsFromEvaluateEditbox(sGroupName);	
}

function ResultsFromEvaluateCheckBox(sGroupName, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.resultsFromEvaluateCheckBox(sGroupName);		
}

function GetQuestionProperty(sAssessID, sQuesID, sProp) {
	var oAssessQuest = new CAssessQuestion(sAssessID, sQuesID);
	return oAssessQuest.getQuestionProperty(sProp);
}

function SetQuestionProperty(sAssessID, sQuesID, sProp, sValue) {
	var oAssessQuest = new CAssessQuestion(sAssessID, sQuesID);
	oAssessQuest.setQuestionProperty(sProp,sValue);	
}

function CalculateLatency() {
	return new CQuestion().calculateLatency();
}

function GetNumOfTries(lEventID) {
	return new CQuestion().getNumberOfTries();
}

function GetQuestionID(lEventID) {
	var oQuest = new CQuestion(lEventID);
	return oQuest.getQuestionID();
}

function GetAssessmentID(lEventID) {
	var oQuest = new CQuestion(lEventID);
	return oQuest.getAssessmentID();
}

function GetQuestionType(lEventID) {
	var oQuest = new CQuestion(lEventID);
	return oQuest.getQuestionType();	
}

function GetCorrectAns(obj) {
	return new CQuestion().getCorrectAns(obj);
}

function GetStudentAns(obj) {
	return new CQuestion().getStudentAns(obj);
}

function GetGroupCorrectAns(sGroupName, bAsString, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.getGroupCorrectAns(sGroupName,bAsString);
}

function GetGroupStudentAns(sGroupName, bAsString, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.getGroupStudentAns(sGroupName,bAsString);
}

function GetAttemptsAtQuestion() {
	return new CQuestion().getAttemptsAtQuestion();
}

function IsChecked(sContentName, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	return oQuest.isChecked(sContentName);
}

function GetOptionFrameNumber(sGroupName, windowtarget) {
	var oOption = new COptionButton(sGroupName, windowtarget);
	return oOption.getOptionFrameNumber();
}

function ShowCorrectBullets(sBulletPrefix, bShowAttemptedOnly, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	oQuest.showCorrectBullets(sBulletPrefix,bShowAttemptedOnly);
}

function ShowIncorrectBullets(sBulletPrefix, bShowAttemptedOnly, windowtarget) {
	var oQuest = new CQuestion(null, windowtarget);
	oQuest.showIncorrectBullets(sBulletPrefix, bShowAttemptedOnly);
}

function GetCorrectOnFinal() {
	return new CQuestion().getCorrectOnFinal();
}

//---------- Assessment Functions -----------//
function GetAssessmentScore(sAssessID, bBlankWrong, bReportScore) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getScore(bBlankWrong, bReportScore);
}

function GetAssessmentPassFail(sAssessID, bBlankWrong) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getPassFail(bBlankWrong);
}

function GetAssessmentTable(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getTable();	
}

function ReportAssessmentScore(sAssessID, sScore) {
	var oAssess = new CAssessment(sAssessID);
	oAssess.reportScore(sScore);
}

function ReportAllInteractions(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	oAssess.reportAllInteractions();
}

function GetObjectiveIDForAssessment(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getFirstObjectiveID();
}

function GetNumberOfQuestionsInAssessment(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getNumberOfQuestions();
}

function GetTotalCorrectInAssessment(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getTotalCorrect();
}

function GetTotalIncorrectInAssessment(sAssessID, bBlankWrong) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getTotalIncorrect(bBlankWrong);
}

function IsAssessmentExists(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.isAssessmentExists();
}

function GetMasterExam(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getMasterExam();
}

function GetMasteryScore(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getMasteryScore();
}

function GetAllAssessments() {
	return new CAssessment().getAllAssessments();
}

function GetAssessmentTokens() {
	return new CAssessment().getAssessmentTokens();
}

function GetTotalAssessments() {
	return new CAssessment().getTotalAssessments();
}

function GetAllQuestions(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getAllQuestions();
}

function GetQuestionTokens(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getQuestionTokens();
}

function GetAllObjectiveID(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getAllObjectiveID();
}

function GetObjectiveIDTokens(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getObjectiveIDTokens();
}

function GetLastObjectiveID(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	return oAssess.getLastObjectiveID();
}

function GetQuestionName(sAssessID, sQuestionID) {
	var oAQuest = new CAssessQuestion(sAssessID,sQuestionID);
	return oAQuest.getName();
}

function GetQuestionWeightage(sAssessID, sQuestionID) {
	var oAQuest = new CAssessQuestion(sAssessID,sQuestionID);
	return oAQuest.getWeightage();
}

//---------- Audio Functions -----------//
function GetAudioFilename(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	return oAudio.getAudioFilename();
}

function SetAudioFile(sFrameObjectName, sAudPath, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.setAudioFile(sAudPath);
}

function GetVideoFilename(sFrameObjectName, windowtarget) {
	var oVideo = new CVideo(sFrameObjectName, windowtarget);
	return oVideo.getVideoFilename();
}

function SetVideoFile(sFrameObjectName, sVidPath, windowtarget) {
	var oVideo = new CVideo(sFrameObjectName, windowtarget);
	oAudio.setVideoFile(sVidPath);
}

function GetAudioAltHTML(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	return oAudio.getAudioAltHTML();
}

function GetAudioShowControls(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	return oAudio.getAudioShowControls();
}

function GetAudioAutoStart(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	return oAudio.getAudioAutoStart();
}

function AudioPlay(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.audioPlay();
}

function AudioStop(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.audioStop();	
}

function AudioPause(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.audioPause();		
}

function IntroAudioPlay() {
	new CAudio().introAudioPlay();
}

function IntroAudioStop() {
	new CAudio().introAudioStop();	
}

function IntroAudioPause() {
	new CAudio().introAudioPause();
}

function ToggleAudio() {
	new CAudio().toggleAudio();
}

function GetPlayerVersion(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	return oAudio.getPlayerVersion();
}

function GetVolume(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	return oAudio.getVolume();
}

function SetVolume(sFrameObjectName, nVolume, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.setVolume(nVolume);
}

function NextTrack(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.nextTrack();
}

function PreviousTrack(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.previousTrack();
}

function VolumeDown(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.volumeDown();
}

function VolumeUp(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.volumeUp();
}

function MuteVolume(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.muteVolume();
}

function Forward(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.forward();
}

function FastForward(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.fastForward();
}

function SetNormal(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.setNormal();
}

function Balance(sFrameObjectName, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName, windowtarget);
	oAudio.balance();
}

//video
function Rewind(sFrameObjectName, windowtarget) {
	var oVideo = new CVideo(sFrameObjectName, windowtarget);
	oVideo.rewind();
}

//---------- Get Name Functions -----------//
function GetCourseName() {
	return new CSCO().getName();
}

function GetEventName() {
	return new CEvent().getName();
}

function GetEventNameFromID(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getName();
}

function GetParentEventName() {	
	return new CEvent().getParentEventName();
}

function GetParentNavName() {
	return new CSCOStructure().getParentNavName();
}

function GetFrameNameForFrameNum(nIndex) {
	return new CEvent().getFrame(nIndex).getName();
}

function GetCurrentFrameObjectName(obj) {
	return new CFrameObject(obj).getCurrentFrameObjectName();
}

function GetButtonNavName(nIndex) {
	return new CEvent().getButtonNavName(nIndex);
}

//---------- Breadcrumb Functions -----------//
function GetBreadcrumbs() {
	return new CEvent().getBreadcrumbs();
}

function GetBreadcrumbsNoURL() {
	return new CEvent().getBreadcrumbsNoURL();
}

// new
function GetTopicBreadcrumb() {
	return new CEvent().getTopicBreadcrumb();
}

function GetPageBreadcrumb() {
	return new CEvent().getPageBreadcrumb();
}

//---------- Frame Object Functions -----------//
function GetText(sFrameObjectName, windowtarget) {
	var oText = new CText(sFrameObjectName, windowtarget);
	return oText.getText();
}

function SetText(sFrameObjectName, sText, windowtarget) {
	var oText = new CText(sFrameObjectName, windowtarget);
	oText.setText(sText);
}

function GetOptionCaption(sFrameObjectName, windowtarget) {
	var oOption = new COptionButton(sFrameObjectName, windowtarget);
	return oOption.getOptionCaption();
}

function SetOptionCaption(sFrameObjectName, scaption, windowtarget) {
	var oOption = new COptionButton(sFrameObjectName, windowtarget);
	oOption.setOptionCaption(scaption);	
}

function GetOptionChecked(sFrameObjectName, windowtarget) {
	var oOption = new COptionButton(sFrameObjectName, windowtarget);
	return oOption.getOptionChecked();
}

function SetOptionChecked(sFrameObjectName, sValue, windowtarget) {
	var oOption = new COptionButton(sFrameObjectName, windowtarget);
	oOption.setOptionChecked(sValue);
}

function GetCheckboxCaption(sFrameObjectName, windowtarget) {
	var oChk = new CCheckbox(sFrameObjectName, windowtarget);
	return oChk.getCheckboxCaption();	
}

function SetCheckboxCaption(sFrameObjectName, sCaption, windowtarget) {
	var oChk = new CCheckbox(sFrameObjectName, windowtarget);
	oChk.setCheckboxCaption(sCaption);
}

function GetCheckboxChecked(sFrameObjectName, windowtarget) {
	var oChk = new CCheckbox(sFrameObjectName, windowtarget);
	return oChk.getCheckboxChecked();
}

function SetCheckboxChecked(sFrameObjectName, sValue, windowtarget) {
	var oChk = new CCheckbox(sFrameObjectName, windowtarget);
	oChk.setCheckboxChecked(sValue);
}

function GetEditboxValue(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxValue();
}

function SetEditboxValue(sFrameObjectName, sValue, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	oEdt.setEditboxValue(sValue);
}

function GetImage(sFrameObjectName, windowtarget) {
	var oImg = new CImage(sFrameObjectName, windowtarget);
	return oImg.getImage();
}

function SetImage(sFrameObjectName, sSrc, windowtarget) {
	var oImg = new CImage(sFrameObjectName, windowtarget);
	oImg.setImage(sSrc);
}

function GetAlphaTransparency(sFrameObjectName, windowtarget) {
	return new CEvent().getImageObject(sFrameObjectName).getAlphaTransparency();
}

function GetButtonCaption(sFrameObjectName, windowtarget) {
	var oBtn = new CButton(sFrameObjectName, windowtarget);
	return oBtn.getButtonCaption();
}

function SetButtonCaption(sFrameObjectName, sCaption, windowtarget) {
	var oBtn = new CButton(sFrameObjectName, windowtarget);
	oBtn.setButtonCaption(sCaption);
}

function GetButtonImage(sFrameObjectName, sState, windowtarget) {
	var oBtn = new CButton(sFrameObjectName, windowtarget);
	return oBtn.getButtonState(sState);
}

function SetButtonImage(sFrameObjectName, sState, sSrc, windowtarget) {
	var oBtn = new CButton(sFrameObjectName, windowtarget);
	oBtn.setButtonState(sState, sSrc);
}

function GetMultistateImage(sFrameObjectName, sState, windowtarget) {
	var oMsi = new CMultistateImage(sFrameObjectName, windowtarget);
	return oMsi.getMultistateImage(sState);
}

function SetMultistateImage(sFrameObjectName, sState, sSrc, windowtarget) {
	var oMsi = new CMultistateImage(sFrameObjectName, windowtarget);
	oMsi.setMultistateImage(sState,sSrc);
}

function GetOptionJumpToPath(sFrameObjectName, windowtarget) {
	return new CEvent().getOptionObject(sFrameObjectName).getOptionJumpToPath();
}

function IsFrameObjectExists(sFrameObjectName, windowtarget) {
	return new CFrameObject(sFrameObjectName).isFrameObjectExists();
}

function IsObjectGroupExists(sFrameObjectGroup, windowtarget) {
	return new CFrameObject(sFrameObjectGroup).isObjectGroupExists();
}

// new 
function GetFrameObjectPositionAndSize(sFrameObjectName) {
	return new CFrameObject(sFrameObjectName).getPositionAndSize();
}

//---------- Replace Functions -----------//
function ReplaceWithExpression(sFrameObjectName, sExpr, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithExpression(sExpr);
}

function ReplaceWithContent(sFrameObjectName, sSrcFrameListObjectName, bKeepFormatting, windowtarget, srcwindowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithContent(sSrcFrameListObjectName,bKeepFormatting,srcwindowtarget);
}

function ReplaceButtonWithExpression(sFrameObjectName, sExpr, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceButtonWithExpression(sExpr);
}

function ReplaceWithCourseName(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithCourseName();
}

function ReplaceWithEventName(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithEventName();	
}

function ReplaceWithParentEventName(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithParentEventName();		
}

function ReplaceWithParentNavName(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithParentNavName();		
}

function ReplaceWithBreadcrumbs(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceWithBreadcrumbs();			
}

function ReplaceButtonWithNavName(sFrameObjectName, nIndex, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.replaceButtonWithNavName(nIndex);
}

function GetContent(sFrameObjectName, bKeepFormatting, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	return oFrmObj.getContent(bKeepFormatting);
}

function SetContent(sFrameObjectName, sContent, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.setContent(sContent);	
}

//---------- Object Animation Functions -----------//
function CreateAnimationGroup(sFrameListObjects, windowtarget) {
	var oAnim = new CAnimateFrameObject(windowtarget);
	return oAnim.createAnimationGroup(sFrameListObjects);
}

function MoveAnimationGroup(arrAnimGroup, x, y, windowtarget) {
	var oAnim = new CAnimateFrameObject(windowtarget);
	oAnim.moveAnimationGroup(arrAnimGroup,x,y);	
}

function CreateAnimationGroupFromLayer(sLayerName, windowtarget) {
	var oAnim = new CAnimateLayer(windowtarget);
	return oAnim.createAnimationGroupFromLayer(sLayerName);
}

function FlyInLayerFromLeft(sLayerName, nSpeed, funcOnDoneMove, nStartingX) {
	new CAnimateLayer().flyInLayerFromLeft(sLayerName,nSpeed,funcOnDoneMove,nStartingX);
}

function FlyInLayerFromRight(sLayerName, nSpeed, funcOnDoneMove, nStartingX) {
	new CAnimateLayer().flyInLayerFromRight(sLayerName,nSpeed,funcOnDoneMove,nStartingX);
}

function FlyInLayerFromTop(sLayerName, nSpeed, funcOnDoneMove, nStartingX) {
	new CAnimateLayer().flyInLayerFromTop(sLayerName,nSpeed,funcOnDoneMove,nStartingX);
}

function FlyInLayerFromBottom(sLayerName, nSpeed, funcOnDoneMove, nStartingX) {
	new CAnimateLayer().flyInLayerFromBottom(sLayerName,nSpeed,funcOnDoneMove,nStartingX);
}

/*
// new
function AnimateResizeFrameObject(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc,windowtarget) {
	new CAnimateFrameObject(windowtarget).animateResizeObject(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc);
}

function AnimateResizeFrameObjectRecurse(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc,windowtarget) {
	new CAnimateFrameObject(windowtarget).animateResizeObjectRecurse(sFrameObjectName,startX,startY,startWidth,startHeight,endX,endY,endWidth,endHeight,duration,refreshRate,fnc);
}

function MoveLayerByName(sLayerName,startX,startY,endX,endY,duration,refreshRate,fnc,windowtarget) {
	new CAnimateLayer(windowtarget).moveLayerByName(sLayerName,startX,startY,endX,endY,duration,refreshRate,fnc);
}

function AnimateMoveLayerRecurse(sLayerGroup,startX,startY,endX,endY,duration,refreshRate,fnc,windowtarget) {
	new CAnimateLayer(windowtarget).animateMoveLayerRecurse(sLayerGroup,startX,startY,endX,endY,duration,refreshRate,fnc);
}
*/
//---------- Multistate Object Functions -----------//
function SetButtonState(sFrameListObject, sState, windowtarget) {
	var oBtn = new CButton(sFrameListObject, windowtarget);
	oBtn.setButtonState(sState);
}

function GetButtonState(sFrameListObject, windowtarget) {
	var oBtn = new CButton(sFrameListObject, windowtarget);
	return oBtn.getButtonState();	
}

function GetButtonDefaultState(sFrameObjectName, windowtarget) {
	return new CButton(sFrameObjectName).getButtonDefaultState();
}

function IsButtonEnabled(sFrameListObject, windowtarget) {
	var oBtn = new CButton(sFrameListObject, windowtarget);
	return oBtn.isButtonEnabled();		
}

function SetMultistateImageState(sFrameListObject, sState, windowtarget) {
	var oMsi = new CMultistateImage(sFrameListObject, windowtarget);
	oMsi.setMultistateImageState(sState);
}

function GetMultistateImageState(sFrameListObject, windowtarget) {
	var oMsi = new CMultistateImage(sFrameListObject, windowtarget);
	return oMsi.getMultistateImageState();
}

function GetMultistateImageDefaultState(sFrameObjectName, windowtarget) {
	return new CMultistateImage(sFrameObjectName).getMSIDefaultState();
}

//---------- Layer Functions -----------//
function ShowLayer(sLayerName, windowtarget) {
	var oLyr = new CLayer(sLayerName, windowtarget);
	oLyr.showLayer();
}

function HideLayer(sLayerName, windowtarget) {
	var oLyr = new CLayer(sLayerName, windowtarget);
	oLyr.hideLayer();
}

function ShowCascadingLayer(sLayerName, windowtarget) {
	var oLyr = new CLayer(sLayerName, windowtarget);
	oLyr.showCascadingLayer();	
}

function HideCascadingLayer(sLayerName, windowtarget) {
	var oLyr = new CLayer(sLayerName, windowtarget);
	oLyr.hideCascadingLayer();		
}

function GetObjectsInLayer(sLayerName) {
	var oLyr = new CLayer(sLayerName);
	return oLyr.getObjects();
}

function GetObjectTokensInLayer(sLayerName) {
	var oLyr = new CLayer(sLayerName);
	return oLyr.getObjectTokens();
}

function GetLayersInEvent(lEventID) {
	return new CEvent(lEventID).getLayersInEvent();
}

function GetLayerTokensInEvent(lEventID) {
	return new CEvent(lEventID).getLayerTokens();
}

function IsLayerExists(lEventID, sLayerName, windowtarget) {
	return new CEvent(lEventID).isLayerExists(sLayerName);
}

// new
function GetPositionAndSizeForLayer(sLayerName, windowtarget) {
	new CLayer(sLayerName,windowtarget).getPositionAndSizeForLayer();
}

function ShowLayerWithExcludeFrameList(sLayerName, sFrameList, windowtarget) {
	new CLayer(sLayerName,windowtarget).showLayerWithExcludeFrameList(sFrameList);
}

//---------- Misc DOM Object Functions -----------//
function GetFrameObject(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	return oFrmObj.getFrameObjectElement();
}

function MoveObject(sFrameObjectName, x, y, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.moveObject(x,y);
}

function ResizeObject(sFrameObjectName, x, y, width, height, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.resizeFrameObject(x,y,width,height);
}

function SetVisibility(sFrameObjectName, sState, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.setVisibility(sState);
}

function SetLayer(sFrameObjectName, nZIndex, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	oFrmObj.setObjectZIndex(nZIndex);	
}

function GetLayer(sFrameObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFrameObjectName, windowtarget);
	return oFrmObj.getObjectZIndex();
}

// new
function MoveDIV(sDIVid,x,y,windowtarget) {
	new CUtil(windowtarget).moveDIV(sDIVid,x,y);
}

function GetDIVOffsetX(sDIVid,windowtarget) {
	return new CUtil(windowtarget).getDIVOffsetX(sDIVid);
}

function GetDIVOffsetY(sDIVid,windowtarget) {
	return new CUtil(windowtarget).getDIVOffsetY(sDIVid);
}

//---------- Persistence Functions -----------//
function SetEventData(lEventID, sName, sValue) {
	var oEvent = new CEvent(lEventID);
	oEvent.setEventData(sName,sValue);
}

function SetCurrentEventData(sName, sValue) {
	new CEvent().setEventData(sName,sValue);
}

function GetEventData(lEventID, sName) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getEventData(sName);
}

function GetCurrentEventData(sName) {
	return new CEvent().getEventData(sName);
}

function DeleteEventData(lEventID, sName) {
	var oEvent = new CEvent(lEventID);
	oEvent.deleteEventData(sName);
}

function DeleteCurrentEventData(sName) {
	new CEvent().deleteEventData(sName);
}

function DeleteEventAllData(lEventID) {
	var oEvent = new CEvent(lEventID);
	oEvent.deleteEventAllData();
}

function DeleteCurrentEventAllData() {
	new CEvent().deleteEventAllData();
}

function PersistEventAllDataForElement(lEventID, windowtarget) {
	var oEvent = new CEvent(lEventID, windowtarget);
	oEvent.setEventAllData();
}

function PersistCurrentEventAllData(windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	oEvent.setEventAllData();
}

function RetrieveEventAllDataForElement(lEventID, windowtarget) {
	var oEvent = new CEvent(lEventID, windowtarget);
	return oEvent.getEventAllData();
}

function RetrieveCurrentEventAllData(windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	return oEvent.getEventAllData();
}

function GetEventAllDefaultDataForElement(lEventID, windowtarget) {
	var oEvent = new CEvent(lEventID, windowtarget);
	return oEvent.getEventAllDefaultData();
}

function GetCurrentEventAllDefaultDataForElement(windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	return oEvent.getEventAllDefaultData();	
}

//---------- Objective Functions -----------//
function GetOverallObjective() {
	return objObjtv.getOverallObjective();
}

function GetAllSubObjectivesNames() {
	return objObjtv.getAllSubObjectivesNames();
}

function GetAllSubObjectivesDesc() {
	return objObjtv.getAllSubObjectivesDesc();
}

function GetSubObjectiveDesc(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getDescription();
}

function GetObjectiveMet(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getObjectiveMet();
}

function GetAllSubObjectivesNameAndDesc() {
	return objObjtv.getAllSubObjectivesNameAndDesc();
}

function GetAllSubObjectivesNameAndMet() {
	return objObjtv.getAllSubObjectivesNameAndMet();
}

function GetAllSubObjectivesNameDescMet() {
	return objObjtv.getAllSubObjectivesNameDescMet();
}

function GetAssessments(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getAssessments();
}

function GetAssessmentTokens(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getAssessmentTokens();
}

function GetObjectiveEvents(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getEvents();
}

function GetObjectiveEventTokens(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getEventTokens();
}

function IsObjectiveExists(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.isObjectiveExists();
}

function GetStatusForObjective(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getStatusForObjective();
}

function GetStatusForObjectiveVisited(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getStatusForObjectiveVisited();
}

function GetStatusForObjectiveScored(sObjID) {
	var oObjtv = new CObjective(sObjID);
	return oObjtv.getStatusForObjectiveScored();
}

function ReportObjectiveStatusFromAssessment(sAssessID) {
	var oAssess = new CAssessment(sAssessID);
	oAssess.reportObjectiveStatus();
}

function ReportObjectiveStatus(sObjID) {
	var oObjtv = new CObjective(sObjID);
	oObjtv.reportObjectiveStatus();
}

//---------- Cookie Functions -----------//
function SetCookie(sItem, sValue, lexpDays) {
	new CCookie().setCookie(sItem,sValue,lexpDays);
}

function GetCookie(sItem) {
	return new CCookie().getCookie(sItem);
}

//---------- Completion Status Functions -----------//
function TrackCompletionStatus(sBulletStartedPrefix, sBulletStartedPrefix, sFrameListObjectComplete, windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	oEvent.trackCompletionStatus(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete);
}

function TrackCompletionStatusForEvent(sBulletStartedPrefix, sBulletStartedPrefix, sFrameListObjectComplete, sNavLinkPrefix, lEventID, windowtarget) {
	var oEvent = new CEvent(lEventID, windowtarget);
	oEvent.trackCompletionStatus(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete);
}

function TrackCompletionStatusMSI(sBulletPrefix, sFrameListObjectComplete, windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	oEvent.trackCompletionStatusMSI(sBulletPrefix,sFrameListObjectComplete);	
}

function TrackCompletionStatusForEventMSI(sBulletPrefix, sFrameListObjectComplete, sNavLinkPrefix, lEventID, windowtarget) {
	var oEvent = new CEvent(lEventID, windowtarget);
	oEvent.trackCompletionStatusMSIByNavPrefix(sBulletPrefix,sFrameListObjectComplete,sNavLinkPrefix);	
}

function TrackCompletionStatusForFrames(sFrameObjectPrefix, windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	oEvent.trackCompletionStatusForFrames(sFrameObjectPrefix);
}

function SetBulletCompleteForFrames(numBullets, sFrameObjectPrefix, nIndex, windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	oEvent.setBulletCompleteForFrames(numBullets,sFrameObjectPrefix,nIndex);
}

function GetCompletionStatus(sNavLinkName) {
	return new CEvent().getCompletionStatusByNavLink(sNavLinkName);
}

function GetCompletionStatusForEvent(lEventID, sNavLinkName) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getCompletionStatusByNavLink(sNavLinkName);
}

function IsEventComplete(sNavLinkPrefix) {
	return new CEvent().isEventCompleteByNavPrefix(sNavLinkPrefix);
}

function IsEventComplete(lEventID, sNavLinkPrefix) {
	var oEvent = new CEvent(lEventID);
	return oEvent.isEventCompleteByNavPrefix(sNavLinkPrefix);
}

function IsEventVisited(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.isEventVisited();
}

function MarkCurrentEventVisited(sVisited) {
	new CEvent().markEventVisited(sVisited);
}

function MarkEventVisited(lEventID, sVisited) {
	var oEvent = new CEvent(lEventID);
	oEvent.markEventVisited(sVisited);
}

function MarkCurrentEventAndChildrenVisited(sVisited) {
	new CEvent().markEventAndChildrenVisited(sVisited);
}

function MarkEventAndChildrenVisited(lEventID, sVisited) {
	var oEvent = new CEvent(lEventID);
	oEvent.markEventAndChildrenVisited(sVisited);
}

function MarkNavLinkNameAndChildrenVisited(sNavLinkName, sVisited) {
	var oSCOst = new CSCOStructure(sNavLinkName);
	oSCOst.markNavLinkAndChildrenVisited(sVisited);
}

function MarkNavLinkAndChildrenVisited(lNavLinkID, sVisited) {
	var oSCOst = new CSCOStructure(lNavLinkID);
	oSCOst.markNavLinkAndChildrenVisited(sVisited);	
}

function ResetEvent(sID) {
	var oEvent = new CEvent(sID);
	oEvent.resetEvent();
}

function ResetEntireCourse() {
	new CSCOStructure().resetEntireCourse();
}

//---------- Course Map Functions -----------//
function BuildHierarchy(bHideEvents) {
	new CSCOStructure().buildHierarchy(bHideEvents);
}

function SetCourseHierarchyProperties(sOpenFolder, sClosedFolder, sEventIcon, nIndentSpacing, nVerticalSpacing, sInstructions) {
	new CSCOStructure().setCourseHierarchyProperties(sOpenFolder,sClosedFolder,sEventIcon,nIndentSpacing,nVerticalSpacing,sInstructions);
}

function BuildHierarchyXHTMLData(bHideEvents) {
	new CSCOStructure().buildHierarchyXHTMLData(bHideEvents);
}

function BuildHierarchyForFrameObject(sFrameObjectName, windowtarget) {
	var oSCOst = new CSCOStructure(null, windowtarget);
	oSCOst.buildHierarchyForFrameObject(sFrameObjectName);
}

function BuildTopicHierarchyForFrameObject(sFrameObjectName, windowtarget) {
	var oSCOst = new CSCOStructure(null, windowtarget);
	oSCOst.buildTopicHierarchyForFrameObject(sFrameObjectName);
}

function ExpandBranchForCurrentEvent(windowtarget) {
	var oSCOst = new CSCOStructure(null, windowtarget);
	oSCOst.expandBranchForCurrentEvent();
}

function SwapCurrentEventImage(sImg, windowtarget) {
	var oSCOst = new CSCOStructure(null, windowtarget);
	oSCOst.swapCurrentEventImage(sImg);
}

//---------- Simulation Producer Functions -----------//
function GetSimProScoreForCurrentEvent() {
	return new CQuestion().getSimProScore();
}

function LaunchSimPro(path, simType, extension) {
	objUtil.launchSimPro(path, simType, extension);
}

//---------- Page Status Functions -----------//
function GetEventIndex() {
	return new CEvent().getIndex();
}

function GetTotalSiblings() {
	return new CEvent().getTotalSiblings();
}

function GetFrameIndex() {
	return new CEvent().getCurrentFrameID();
}

function GetTotalFrames() {
	return new CEvent().getTotalFrames();
}

function GetLayerIndex(sLayerName, windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	return oEvent.getLayer(sLayerName).getIndex();
}

function GetCurrentLayerIndex(windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	return oEvent.getCurrentLayerIndex();
}

function GetTotalLayers(windowtarget) {
	var oEvent = new CEvent(null, windowtarget);
	return oEvent.getTotalLayers();
}

// new
function IsFirstSibling() {
	return new CEvent().isFirstSibling();
}

function IsLastSibling() {
	return new CEvent().isLastSibling();
}


//---------- Glossary Functions -----------//
function GetAllTerms(sObj, windowtarget) {
	var oGlos = new CGlossary(windowtarget);
	return oGlos.getAllTerms(sObj);
}

function GetTermByLetter(sLetter, sTermsObj, sDefObj, sDefObj, windowtarget) {
	var oGlos = new CGlossary(windowtarget);
	return oGlos.getTermByLetter(sLetter,sTermsObj,sDefObj,sDefObj);
}

function GetDefForTerm(sTerm, sDefObj, windowtarget) {
	var oGlos = new CGlossary(windowtarget);
	return oGlos.getDefForTerm(sTerm,sDefObj);
}

function GetDefForTermEX(sTerm, windowtarget){
    var oGlos = new CGlossary(windowtarget);
	return oGlos.getDefForTermEX(sTerm);
}

function SearchTerms(sTextField, sTermsObj, windowtarget) {
	var oGlos = new CGlossary(windowtarget);
	return oGlos.searchTerms(sTextField,sTermsObj);
}

function GetTermsAndDefsWithFormat(sFormat) {
	return objGlos.getTermsAndDefsWithFormat(sFormat);
}

function GetGroupedTermsAndDefsWithFormat(sFormat) {
	return objGlos.getGroupedTermsAndDefsWithFormat(sFormat);
}

function GetTermBeginningCharWithFormat(sFormat) {
	return objGlos.getTermBeginningCharWithFormat(sFormat);
}

//---------- Miscellaneous Functions -----------//
function IsNumeric(strString) {
	return objUtil.isNumeric(strString); 
}

function GetStringTokens(strString,delimiter) {
	return objUtil.getStringTokens(strString,delimiter);
}

function PrepareDragDrop(sDragE, bDropOnCorrectOnly, bMoveBack, onDropFunc, windowtarget) {
	var oDragDrop = new CDragDrop(windowtarget);
	oDragDrop.prepareDragDrop(sDragE,bDropOnCorrectOnly,bMoveBack,onDropFunc);
}

function AddScriptInclude(sRelativePath) {
	objUtil.addScriptInclude(sRelativePath);
}

function Search(sSearchTerm, sResult, sGroupName, sResultMultipleCaption, sResultSingleCaption, sNoResultCaption) {
	objUtil.search(sSearchTerm,sResult,sGroupName,sResultMultipleCaption,sResultSingleCaption,sNoResultCaption);
}

// new 
function GetDigit(nValue,nDigit) {
	return objUtil.getDigit(nValue,nDigit);
}

//--------- Supporting Event Functions ---------//
function GetEventType(lEventID) {
	return new CEvent(lEventID).getType();
}

function GetEventObjectiveID(lEventID) {
	return new CEvent(lEventID).getObjectiveID();
}

function GetEventIntroAudio(lEventID) {
	return new CEvent(lEventID).getIntroAudio();
}

function GetEventPooledEvents(lEventID) {
	return new CEvent(lEventID).getPooledEvents();
}

function GetEventSyncaction(lEventID) {
	return new CEvent(lEventID).getSyncaction();
}

function GetEventStopAudio(lEventID) {
	return new CEvent(lEventID).getStopAudio();
}

function GetEventTransitionEnter(lEventID) {
	return new CEvent(lEventID).getTransitionEnter();
}

function GetEventDurationTransitionEnter(lEventID) {
	return new CEvent(lEventID).getDurationTransitionEnter();
}

function GetEventHideInCourseMap(lEventID) {
	return new CEvent(lEventID).getHideInCourseMap();
}

function GetEventCourseMapBehaviour(lEventID) {
	return new CEvent(lEventID).getCourseMapBehaviour();
}

function GetEventVisitedStatusPreset(lEventID) {
	return new CEvent(lEventID).getVisitedStatus();
}

// new
function GetTotalChildrenForEvent(lEventID) {
	return new CEvent(lEventID).getTotalChildren();
}

function GetParentIndexForEvent(lEventID) {
	return new CEvent(lEventID).getParentIndex();
}

//--------- Supporting Frame Functions ---------//
function GetFrameIDs() {
	return new CEvent().getFrameIDs();
}

function GetFrameIDTokens() {
	return new CEvent().getFrameIDTokens();
}

function GetFrameNames() {
	return new CEvent().getFrameNames();
}

function GetFrameNameTokens() {
	return new CEvent().getFrameNameTokens();
}

function GetFrameIDAndName() {
	return new CEvent().getFrameIDAndName();
}

function IsFrameExists() {
	return new CEvent().isFrameExists();
}

//--------- Editbox Property Functions ---------//
function GetEditboxDefault(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxDefault();
}

function GetEditboxRows(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxRows();
}

function GetEditboxCols(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxCols();
}

function GetEditboxReadonly(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxReadonly();
}

function GetEditboxMultiline(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxMultiline();
}

function GetEditboxCaseSensitive(sFrameObjectName, windowtarget) {
	var oEdt = new CEditbox(sFrameObjectName, windowtarget);
	return oEdt.getEditboxCaseSensitive();
}

//--------- Flash Functions ---------//
function FlashPlay(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	oFlash.flashPlay();
}

function FlashStop(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	oFlash.flashStop();
}

function GetFlashFilename(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashFilename();
}

function GetFlashLoop(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashLoop();
}

function GetFlashMenu(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashMenu();
}

function GetFlashQuality(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashQuality();
}

function GetFlashBGColor(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashBGColor();
}

function GetFlashWindowMode(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashWindowMode();
}

function GetFlashAltHTML(sFrameObjectName, windowtarget) {
	var oFlash = new CFlash(sFrameObjectName, windowtarget);
	return oFlash.getFlashAltHTML();
}

//--------- Inline Functions ---------//
function GetInlineFrameFilename(sFrameObjectName, windowtarget) {
	var oInline = new CInlineFrame(sFrameObjectName, windowtarget);
	return oInline.getIFrameFilename();
}

function SetInlineFrameURL(sFrameObjectName, sURL, windowtarget) {
	var oInline = new CInlineFrame(sFrameObjectName, windowtarget);
	oInline.setIFrameURL(sURL);
}

function GetInlineFrameAllowTransparency(sFrameObjectName, windowtarget) {
	var oInline = new CInlineFrame(sFrameObjectName, windowtarget);
	return oInline.getIFrameAllowTransparency();
}

function GetInlineFrameBorder(sFrameObjectName, windowtarget) {
	var oInline = new CInlineFrame(sFrameObjectName, windowtarget);
	return oInline.getIFrameFrameBorder();
}

function GetInlineFrameScrolling(sFrameObjectName, windowtarget) {
	var oInline = new CInlineFrame(sFrameObjectName, windowtarget);
	return oInline.getIFrameScrolling();
}

//--------- SCO Functions ---------//
function SetSCOName(sVal) {
	new CSCO().setName(sVal);
}

function GetSCOPersistData() {
	return new CSCO().getPersistData();
}

function SetSCOPersistData(bVal) {
	new CSCO().setPersistData(bVal);
}

function GetSCOAudioSupport() {
	return new CSCO().getAudioSupport();
}

function SetSCOAudioSupport(sVal) {
	new CSCO().setAudioSupport(sVal);
}

function GetSCOUseCompletionStatus() {
	return new CSCO().getUseCompletionStatus();
}

function SetSCOUseCompletionStatus(bVal) {
	new CSCO().setUseCompletionStatus(bVal);
}

function GetSCONavigationBehaviour() {
	return new CSCO().getNavigationBehaviour();
}

function SetSCONavigationBehaviour(sVal) {
	new CSCO().setNavigationBehaviour(sVal);
}

function GetSCOUsesCourseTree() {
	return new CSCO().getUsesCourseTree();
}

function SetSCOUsesCourseTree(bVal) {
	new CSCO().setUsesCourseTree(bVal);
}

function GetSCOTrackingType() {
	return new CSCO().getTrackingType();
}

function SetSCOTrackingType(sVal) {
	new CSCO().setTrackingType(sVal);
}

function SetSCOReportInteraction(bVal) {
	new CSCO().setReportInteraction(bVal);
}

function SetSCOCacheInteractionData(bVal) {
	new CSCO().setCacheInteractionData(bVal);
}

function GetSCOPublishedFilename() {
	return new CSCO().getPublishedFilename();
}

function GetSCOPublishedExtension() {
	return new CSCO().getPublishedExtension();
}

function IsSCOAudioSupported() {
	return new CSCO().isAudioSupported();
}

function IsSCOReportInteracted() {
	return new CSCO().isReportInteracted();
}

function IsSCOCacheInteracted() {
	return new CSCO().isCacheInteracted();
}

function IsSCOBookmarkUsed() {
	return new CSCO().isBookmarkUsed();
}

function IsSCOHACPAppletURLAuthored() {
	return new CSCO().isHACPAppletURLAuthored();
}

//--------- Navlink Functions ---------//
function GetNavlinkReferenceID(lNavID, windowtarget) {
	var oSCOst = new CSCOStructure(lNavID, windowtarget);
	return oSCOst.getRefID();
}

function GetNavlinkName(lNavID, windowtarget) {
	var oSCOst = new CSCOStructure(lNavID, windowtarget);
	return oSCOst.getName();
}

function GetNavlinkAliasName(lNavID, windowtarget) {
	var oSCOst = new CSCOStructure(lNavID, windowtarget);
	return oSCOst.getAliasName();
}

function GetNavlinkHideInCourseMap(lNavID, windowtarget) {
	var oSCOst = new CSCOStructure(lNavID, windowtarget);
	return oSCOst.getHideInCourseMap();
}

function GetExistingTree(sTreeName,enginetarget,windowtarget) {
	var oCBTree = new CBuildTree(sTreeName,enginetarget,windowtarget);
	return oCBTree.getExistingTree();
}

//----------------------------------------------------------//
// Begin Objectives non highlevel API
// --Audio.js-- //
function AudioPath(sFrameObjectName, sAudPath, windowtarget) {
	var oAudio = new CAudio(sFrameObjectName,windowtarget);
	oAudio.setAudioFile(sAudPath);
}

function getFullURLRelativeToEngine(sPath) {
	objUtil.getFullURLRelativeToEngine(sPath);
}

// --dom.js-- //
function MoveAnimationLayer(arrAnimGroup,x,y,windowtarget) {
	var oAnimLyr = new CAnimateLayer(windowtarget);
	oAnimLyr.moveAnimationLayer(arrAnimGroup,x,y);
}

function GetLayerNameFromObject(sFramelistObjectName, windowtarget) {
	var oFrmObj = new CFrameObject(sFramelistObjectName,windowtarget);
	return oFrmObj.getLayerNameForObject();
}

function GetVisibility(sFrameListObjectName,windowtarget) {
	var oFrmObj = new CFrameObject(sFramelistObjectName,windowtarget);
	return oFrmObj.getVisibility();
}

function buildBreadcrumb(lEventID,sURL) {
	new CSCOStructure().buildBreadcrumb(lEventID,sURL);
}

function buildBreadcrumbNoURL(lEventID,sURL) {
	new CSCOStructure().buildBreadcrumbNoURL(lEventID,sURL);
}

// --highlevelapi.js-- //
function BuildHierarchyXHTMLNode(bHideEvents) {
	new CSCOStructure().buildHierarchyXHTMLNode(bHideEvents);	
}

function ExpandBranchTraverse(nType,lID) {
	new CSCOStructure().expandBranchTraverse(nType,lID);
}

function BuildFullURL(sPath) {
	objUtil.buildFullURL(sPath);
}

function GetContentFullURL() {
	return objUtil.getContentFullURL();
}

function XHTMLElement(elementName) {
	return new CXHTMLElement(elementName);
}

function XHTMLAttribute(attributeName) {
	return new CXHTMLAttribute(attributeName);
}

function XHTMLCreateAttribute(oNode,sAttributeName,sAttributeValue) {
	var oXHTMLEl = new CXHTMLElement(oNode);
	oXHTMLEl.XHTMLCreateAttribute(sAttributeName,sAttributeValue);
}

function XHTMLAppendChild(oParentNode,oChildNode) {
	new CSCOStructure().XHTMLAppendChild(oParentNode,oChildNode);
}

function AddGlossaryTerm(sTerm, sObj, windowtarget) {
	var oGlos = new CGlossary(windowtarget);
	oGlos.addGlossaryTerm(sTerm, sObj);
}

function GetAllTermstoDisplay(sObj, windowtarget) {
	var oGlos = new CGlossary(windowtarget);
	return oGlos.getAllTermstoDisplay(sObj);
}

function GetDefForTermEX(sTerm) {
	var oGlos = new CGlossary(windowtarget);
	oGlos.getDefForTermEX(sTerm);
}

function traverseLinksForHierarchy(nOriginType, lOriginID, oNewNode, bHideEvents) {
	new CSCOStructure().traverseLinksForHierarchy(nOriginType,lOriginID,oNewNode,bHideEvents);
}

function createEmptyLeaf(oNewNode) {
	new CSCOStructure().createEmptyLeaf(oNewNode);
}

function createTreeLeaf(oNewNode,oNode,sKey,lDstID,lType) {
	new CSCOStructure().createTreeLeaf(oNewNode,oNode,sKey,lDstID,lType);
}

function createTreeFolder(oNewNode,oNode,sKey,lDstID,nType) {
	new CSCOStructure().createTreeFolder(oNewNode,oNode,sKey,lDstID,nType)
}

function showBranch(branch, windowtarget) {
	var oSCOst = new CSCOStructure(null, windowtarget);
	oSCOst.showBranch(branch);
}

function swapFolder(img, windowtarget) {
		var oSCOst = new CSCOStructure(null, windowtarget);
	oSCOst.swapFolder(img);
}

// --openwindow.js-- //
function isFullURL(sURL) {
	return objUtil.isFullURL(sURL);
}

// --pooledquestion.js-- //
function getPooledEvent(aIDArray) {
	return new CEvent().getEventFromPool(aIDArray);
}

// --question.js-- //
function ShowCorrectOnFinal(windowtarget) {
	var oQuest = new CQuestion(windowtarget);
	oQuest.showCorrectOnFinal();
}

function noCaseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer) {
	return new CQuestion().noCaseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer);
}

function caseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer) {
	return new CQuestion().caseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer);
}

// --simpro.js-- //
function QuestionEvalSimProAndJump() {
	new CQuestion().questionEvalSimProAndJump();
}

function QuestionEvalSimPro() {
	return new CQuestion().questionEvalSimPro();
}

function EvaluateSimProAndJump(lCorrectFrameID,lIncorrectFrameID,lFinalFrameID,lIncompleteFrameID,sAssessmentID,sQuestionID,sQType) {
	new CQuestion().evaluateSimProAndJump(lCorrectFrameID,lIncorrectFrameID,lFinalFrameID,lIncompleteFrameID,sAssessmentID,sQuestionID,sQType);
}

function EvaluateSimPro(sAssessmentID,sQuestionID,sQType) {
	return new CQuestion().evaluateSimPro(sAssessmentID,sQuestionID,sQType);
}

// --status.js-- //
function IsCurrentEventComplete(sNavLinkPrefix) {
	return new CEvent().isEventCompleteByNavPrefix(sNavLinkPrefix);
}

function traverseNavLinksForStatus(nOriginType,lOriginID) {
	new CEvent().traverseNavLinksForStatus(nOriginType,lOriginID);
}

function MarkBulletCompleteForFrames(sFrameObjectPrefix,index) {
	new CEvent().markBulletCompleteForFrames(sFrameObjectPrefix,index);
}

function ShowBulletsCompleteForFrames(numBullets,sFrameObjectPrefix,windowtarget) {
	var oEvent = new CEvent(windowtarget);
	oEvent.showBulletsCompleteForFrames(numBullets,sFrameObjectPrefix);
}

function MarkEventCompletionStatus(lEventID) {
	var oEvent = new CEvent(lEventID);
	oEvent.markEventCompletionStatus();
}

function MarkItemCompletion(oItem) {
	new CSCOStructure().markItemCompletion(oItem);
}

function checkSiblings(oItem) {
	new CSCOStructure().checkSiblings(oItem);
}

function MarkTreeItemCompletion(oItem,sStatus) {
	new CSCOStructure().markTreeItemCompletion(oItem,sStatus);
}

function markNodeAndChildrenVisited(nType,lID,sVisited) {
	new CSCOStructure().markNodeAndChildrenVisited(nType,lID,sVisited);
}

// --wrapper.js-- //
function MarkCompletionForChildSCO(sSCOID,lEventID,sNavLinkName) {
	var oCookie = new CCookie(sSCOID);
	oCookie.markCompletionForChildSCO(lEventID,sNavLinkName);
}

function NavigateChildURL(sURL) {
	new CCookie().navigateChildURL(sURL);
}

function NavigateParentSCO(sURL) {
	new CCookie().navigateParentSCO(sURL);
}

function TrackCompletionStatusForWrapper(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete,windowtarget) {
	var oCookie = new CCookie(windowtarget);
	oCookie.trackCompletionStatusForWrapper(sBulletStartedPrefix,sBulletCompletePrefix,sFrameListObjectNameComplete);
}

function GetVisitedString() {
	return new CCookie().getVisitedString();
}

function SetVisitedStatus(visitedString) {
	new CCookie().setVisitedString(visitedString);
}

function CookieGetValue(sSCOID,sItem) {
	var oCookie = new CCookie(sSCOID);
	return oCookie.getCookie(sItem);
}

// -- objective.js-- //
function loadAllObjectives(){
  for (var i in m_arrEvents){
    if (m_arrEvents[i].OBJECTIVEID != null) {
      if (m_arrEvents[i].OBJECTIVEID != ""){
        oObjectiveID = m_arrEvents[i].OBJECTIVEID;
        if (oObjectiveID.indexOf("|") != -1){
          oArrayObjID = oObjectiveID.split("|");
        }else{
          oArrayObjID = new Array();
          oArrayObjID[0] = oObjectiveID;
        } 
        for (var j=0;j<oArrayObjID.length;j++){
          if (m_arrObjectives[oArrayObjID[j]] != null){	
          	m_arrObjectives[oArrayObjID[j]].EVENTS = arrPush(m_arrObjectives[oArrayObjID[j]].EVENTS, m_arrEvents[i].ID);	
		  }	          	
        }        
      }
    }      
  }    
}

// --navigation.js-- //
function GotoEventIfBookmark() {
	new CSCOStructure().gotoEventIfBookmark();
}

function GotoLayerByName(lLayerIndex,sPrefix,bPersistPrevious) {
	new CEvent().gotoLayerByIndexAndPrefix(lLayerIndex,sPrefix,bPersistPrevious);
}

function GetCurrentEventRefNumFromName() {
	return new CEvent().getRefID();
}

function saveHistory(lEventID) {
	var oEvent = new CEvent(lEventID);
	oEvent.saveHistory();
}

function loadEvent(lEventID, lFrameID, sSCOID, sBMAnchor) {
	var oEvent = new CEvent(lEventID);
	oEvent.loadEvent(lFrameID,sSCOID,sBMAnchor);
}

function loadFrame(lEventID, lFrameID, bLoadEvent, sBMAnchor) {
	var oFrame = new CFrame(lFrameID);
	oFrame.loadFrame(lEventID,bLoadEvent,sBMAnchor);
}

function getTarget(lEventID) {
	var oEvent = new CEvent(lEventID);
	return oEvent.getTarget(); 
}

function getID(srcElement) {
	return objUtil.getID(srcElement);
}

function replaceAll(sStr,sFind,sReplace) {
	return objUtil.replaceAll(sStr,sFind,sReplace);
}

function getRandom(count) {
	return objUtil.getRandom(count);
}

function getTreeNavPos() {
	return new CEvent().getTreeNavPos();
}

function unswapImages() {
	objUtil.unswapImages();
}

//--show CP error --//
function ShowCPError(bVal) {
	objUtil.showCPError(bVal);
}


// --audioevent.js-- //
function audioMarkerHit(lMarkerNum) {
	// Advances to the next frame in the event; you can remove this if you want to perform a different action 
	if (m_AudioSyncAction == "Next Frame"){
		GotoNextFrame();
	} else if(m_AudioSyncAction == "Next Event"){
		GotoNextEvent();  
	}  	  
}

function audioStopped() {
}

function audioPaused() {
}

function audioPlaying() {
}

function audioScanForward() {
}

function audioScanReverse() {
}

function audioBuffering() {
}

function audioWaiting() {
}

function audioMediaEnded() {
}

function audioTransitioning() {
}

function audioReady() {
}

function audioRespondToEvent(newState) {
	switch (newState){
		case 1:
			audioStopped();
	   	break;
	
		case 2:
			audioPaused();
	   	break;
	
		case 3:
			audioPlaying();
	   	break;
	
		case 4:
			audioScanForward();
	   	break;
	
		case 5:
			auudioScanReverse();
	   	break;
	
		case 6:
			audioBuffering();
	   	break;
	
		case 7:
			audioWaiting();
	   	break;
	
		case 8:
			audioMediaEnded();
	   	break;
	
		case 9:
			audioTransitioning();
	   	break;
	
		case 10:
			audioReady();
	   	break;
	
	  default:
	}
}