﻿function CAssessment(sAssessID) {
	//------------property declaration-------------//
	this.assessID									=	sAssessID;


	//----------validate the assessment before setting properties----------//
	this.isAssessmentExists							=	_isAssessmentExists;
	
	if(sAssessID != null && m_arrAssessments[sAssessID] != null && this.isAssessmentExists() == true) {
		this.masteryScore							=	m_arrAssessments[sAssessID].MASTERYSCORE;
		this.masterExam								=	m_arrAssessments[sAssessID].MASTEREXAM;
		this.arrNQuestions						=	m_arrAssessments[sAssessID].arrQuestions;
		this.arrNColumns							=	m_arrAssessments[sAssessID].arrColumns;
		this.tableRow									=	m_arrAssessments[sAssessID].ROW;
		this.headerRow								=	m_arrAssessments[sAssessID].HEADERROW;
	}
	
	
	//------------method declaration-------------//
	this.getAllAssessments				=	_getAllAssessments;	
	this.getAssessmentTokens			=	_getAssessmentTokens;
	this.getTotalAssessments			=	_getTotalAssessments;	
	
	this.getQuestion							=	_getQuestion;
	this.getMasteryScore					=	_getMasteryScore;	
	this.getMasterExam						=	_getMasterExam;
	
	this.getNumberOfQuestions			=	_getNumberOfQuestions;
	this.getAllQuestions					=	_getAllQuestions;
	this.getQuestionTokens				=	_getQuestionTokens;
	this.getScore									=	_getScore;
	this.reportScore							=	_reportScore;
	this.getPassFail							=	_getPassFail;
	this.getTable									=	_getTable;
	this.reportAllInteractions		=	_reportAllInteractions;
	this.getFirstObjectiveID			=	_getFirstObjectiveID;						//GetObjectiveIDForAssessment()
	this.getAllObjectiveID				=	_getAllObjectiveID;
	this.getObjectiveIDTokens			=	_getObjectiveIDTokens;
	this.getLastObjectiveID				=	_getLastObjectiveID;
	this.getTotalCorrect					=	_getTotalCorrect;
	this.getTotalIncorrect				=	_getTotalIncorrect;
	this.reportObjectiveStatus		= _reportObjectiveStatus;


	//------------method definition-------------//
	function _getQuestion(sQID) {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}		
		var objAssessQuestion = new CAssessQuestion(sAssessID,sQID);
		return objAssessQuestion;
	}
	
	function _isAssessmentExists() {
		for(nAssessID in m_arrAssessments) {
			if(nAssessID == this.assessID) {
				return true;
			}
		}
		return false;
	}	


	function _getMasterExam() {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}		
		return this.masterExam;
	}


	function _getMasteryScore() {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}		
		return this.masteryScore;
	}

	function _getAllAssessments() {
	  var sResult = "";
	  for (var i in m_arrAssessments){
	  		sResult = sResult + "|" + i;
	  }	  
	  sResult = sResult.substring(1);
	  return sResult;
	}
	
	function _getAssessmentTokens() {
		var str = this.getAllAssessments();
		return str.split("|");
	}
	
	function _getTotalAssessments() {
	  var icnt = 0;
	  for (var i in m_arrAssessments){
	  		icnt++;
	  }	
	  return icnt;
	}
	
	function _getNumberOfQuestions() {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		if(m_arrAssessments[this.assessID] == null){
	  		return 0;
	  }			
	  var icnt = 0;
	  for (var i in this.arrNQuestions){
	  		icnt++
	  }	
	  return icnt;
	}

	
	function _getAllQuestions() {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		var sResult = "";
		if(m_arrAssessments[this.assessID] == null){
	  		return "";
	  }			
	  for (var i in this.arrNQuestions){
	  		sResult = sResult + "|" + i;
	  }	
	  sResult = sResult.substring(1);
	  return sResult;
	}	
	
	
	function _getQuestionTokens() {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		var str = this.getAllQuestions();
		var arrResult = str.split("|");
		return arrResult;
	}
	
	
	function _getScore(bBlankWrong, bReportScore) {				// GetAssessMentScore
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
	  var studentPoints = 0;
	  var totalPoints = 0;
	  
	  bBlankWrong = Boolean(bBlankWrong);
	  bReportScore = Boolean(bReportScore);
	  
	  if (bReportScore == null || ""+bReportScore=="undefined"){
	  	bReportScore = true;		
	  }	
	  if (bBlankWrong == null ||  ""+bBlankWrong=="undefined"){
	  	bBlankWrong = true;  
	  }
	  if (m_arrAssessments[this.assessID] == null){
		  return "The assessment '" + this.assessID + "' was not found.  Either the assessment has not been created or the screen name does not match the name of the assessment.";
		}
		
	  for (var i in this.arrNQuestions) {
	  		var objAssQst = new CAssessQuestion(this.assessID, i);	
	  		
	      if (objAssQst.result != null){
	        if (objAssQst.result.toLowerCase() == "correct"){
	          studentPoints = parseFloat(studentPoints) + parseFloat(objAssQst.weight);
	        }
	        totalPoints = parseFloat(totalPoints) + parseFloat(objAssQst.weight);
	      }else{
	        if (bBlankWrong){
	          totalPoints = parseFloat(totalPoints) + parseFloat(objAssQst.weight);  
	        }
	      }          
	    }        
	    
	  if (totalPoints == 0){
	    return 0;    
	  } 
	  if (bReportScore){
	  	this.reportScore(Math.round((studentPoints/totalPoints)*100));
	  }	
	  return Math.round((studentPoints/totalPoints)*100);	
	}


	function _reportScore(score) {												// ReportAssessmentScore
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			if (this.masterExam == "1"){  
		    	lmsSetScore(score);
			}      
		}
	}	

	
	function _getPassFail(bBlankWrong) {
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		bBlankWrong = Boolean(bBlankWrong);
		
		if (m_arrAssessments[this.assessID] == null){
		  return "The assessment '" + this.assessID + "' was not found.  Either the assessment has not been created or the screen name does not match the name of the assessment.";
		}	
	  var studentScore = this.getScore(bBlankWrong, true);
	  var sMasteryScore = parseInt(this.masteryScore);
	  if (studentScore >= sMasteryScore){
	    return "P";
	  }else{
	    return "F";
	  }  		
	}
	
	
	function _getTable(){
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		if (m_arrAssessments[this.assessID] == null){
		  return "The assessment '" + this.assessID + "' was not found.  Either the assessment has not been created or the screen name does not match the name of the assessment.";
		}
		if (this.headerRow == null){
		  return "You must create an assessment table to display the results.  Click on the Results Table button from the assessment dialog."
		}  
		var oP = new CXHTMLElement("P");
		var oTable = new CXHTMLElement("TABLE");
		var oAttr = new CXHTMLAttribute("BORDER");
		oAttr.text = this.headerRow.BORDER;
		oTable.setAttribute(oAttr);  
		var oAttr = new CXHTMLAttribute("WIDTH");
		oAttr.text = "90%";
		oTable.setAttribute(oAttr);
		var oHeaderRow = new CXHTMLElement("TR");
		var oAttr = new CXHTMLAttribute("style");
		oAttr.text = "background-color: " + this.headerRow.BGCOLOR;
		oHeaderRow.setAttribute(oAttr);
		var oAttr = new CXHTMLAttribute("class");
		oAttr.text = this.headerRow.FONTSTYLE;
		oHeaderRow.setAttribute(oAttr);
	
		for (var i in this.arrNColumns){
			if (this.arrNColumns[i].SELECTED == "True"){
				var oTD = new CXHTMLElement("TD");
				oTD.text = this.arrNColumns[i].ALIAS;
				var oAttr = new CXHTMLAttribute("style");
				oAttr.text = "text-align: " + this.arrNColumns[i].ALIGN;
				oTD.setAttribute(oAttr);
				oHeaderRow.appendChild(oTD); 
			}			
		}
		oTable.appendChild(oHeaderRow);	
		var k=0;
		for (var i in this.arrNQuestions){
			oRow = new CXHTMLElement("TR");
			var oStyle = new CXHTMLAttribute("style");
			var oClass = new CXHTMLAttribute("class");
			if (k%2==0){	
				oStyle.text = "background-color: " + this.tableRow.ODDROWBGCOLOR;
				oRow.setAttribute(oStyle);
				oClass.text = this.tableRow.ODDROWFONTSTYLE;
				oRow.setAttribute(oClass);
			}else{
				oStyle.text = "background-color: " + this.tableRow.EVENROWBGCOLOR;
				oRow.setAttribute(oStyle);
				oClass.text = this.tableRow.EVENROWFONTSTYLE;
				oRow.setAttribute(oClass);
			}				
			for (var j in this.arrNColumns){
				if (this.arrNColumns[j].SELECTED == "True"){
					oTD = new CXHTMLElement("TD");
					
					var objAssQst = new CAssessQuestion(this.assessID, this.arrNQuestions[i].ID);
					var s = new String(objAssQst.getQuestionProperty(this.arrNColumns[j].ID));
					var oStyle = new CXHTMLAttribute("style");
					
					oStyle.text = "text-align: " + this.arrNColumns[j].ALIGN;
					oTD.setAttribute(oStyle);
					oTD.text = s.replace(",",", ");
					oRow.appendChild(oTD); 
				}				
			}
			oTable.appendChild(oRow);	
			k++;
		}
		oP.appendChild(oTable);		
	  return oP.xhtml();
	}	
	
	
	function _reportAllInteractions(){
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			for (var i in this.arrNQuestions){
				sQues = this.arrNQuestions[i].ID;      
				
				var objAssQst = new CAssessQuestion(this.assessID, sQues);
				var sQtype = objAssQst.getQuestionProperty("QTYPE");
				var sResult = objAssQst.getQuestionProperty("RESULT");
				
				if (sQtype != "performance"){
					if (sResult.toLowerCase() == "incorrect" || sResult.toLowerCase() == "final"){
						sResult = "wrong";	
					}	
				}	
				var sCorrectAns = objAssQst.getQuestionProperty("CORRECTANSWER");
					
					if (sQtype != "performance"){
						if (sResult.toLowerCase() == "correct"){
							var sCorrectAns = objAssQst.getQuestionProperty("STUDENTANSWER");
						}else{
							var sCorrectAns = objAssQst.getQuestionProperty("CORRECTANSWER");
						}
					}	
					//getobjectiveidforass		//test
					lmsSetQuestionData(sQues,objAssQst.getQuestionProperty("QTYPE"),sCorrectAns,objAssQst.getQuestionProperty("STUDENTANSWER"),sResult,objAssQst.getQuestionProperty("LATENCY"),objAssQst.getQuestionProperty("WEIGHT"),this.getFirstObjectiveID()); 
			}        
		}		
	}	
	
	
	function _getFirstObjectiveID(){
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		for (var i in m_arrObjectives){
	      if (m_arrObjectives[i].ASSESSMENTS !=null){
	        var sAssess = m_arrObjectives[i].ASSESSMENTS.split("^,^");
	        for (var j=0;j<sAssess.length;j++){
	          if (sAssess[j] == this.assessID){
	            return m_arrObjectives[i].ID;
	          }
	        }
	      }        
	    }
	    return "";
	}	
	
	
	function _getAllObjectiveID(){
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		var sResult = "";
		
		for (var i in m_arrObjectives){
	      if (m_arrObjectives[i].ASSESSMENTS !=null){
	        var sAssess = m_arrObjectives[i].ASSESSMENTS.split("^,^");
	        for (var j=0;j<sAssess.length;j++){
	          if (sAssess[j] == this.assessID){
	            sResult = sResult + "|" + m_arrObjectives[i].ID;
	          }
	        }
	      }        
	    }
	    
	    if(sResult != "")  {
	    	sResult = sResult.substring(1);
	  	}
	    return sResult;
	}	
		

	function _getObjectiveIDTokens(){
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		var arrResult;
		var str = this.getAllObjectiveID();
		arrResult = str.split("|");
	  return arrResult;
	}	
		

	function _getLastObjectiveID(){
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		var sResult = "";
		for (var i in m_arrObjectives){
	      if (m_arrObjectives[i].ASSESSMENTS !=null){
	        var sAssess = m_arrObjectives[i].ASSESSMENTS.split("^,^");
	        for (var j=0;j<sAssess.length;j++){
	          if (sAssess[j] == this.assessID){
	            sResult = m_arrObjectives[i].ID;
	          }
	        }
	      }        
	    }
	    return sResult;
	}	
	
	
	function _getTotalCorrect() {					//GetTotalCorrectInAssessment()
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		if (m_arrAssessments[this.assessID] == null){
			return "[Assessment Not Defined]";
		}			
		var icnt = 0;
		for (var i in this.arrNQuestions){
			if (this.arrNQuestions[i].RESULT != null){
				if (this.arrNQuestions[i].RESULT.toLowerCase() == "correct"){
					icnt++;
				}
			}          
		}        
		return icnt;
	}	


	function _getTotalIncorrect(bBlankWrong) {				//GetTotalIncorrectInAssessment()
		if(this.isAssessmentExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.assessID + " assessment doesn't exists.");
			}
			return null;
		}
		
		bBlankWrong = Boolean(bBlankWrong);
		if (m_arrAssessments[this.assessID] == null){
			return "[Assessment Not Defined]";
		}	
		var icnt = 0;
		for (var i in this.arrNQuestions){
			if (this.arrNQuestions[i].RESULT != null){
				if (this.arrNQuestions[i].RESULT.toLowerCase() == "incorrect"){
					icnt++;
				}
			}else{
				if (bBlankWrong){
					icnt++;
				}	
			}          
		}        
		return icnt;
	}
	
	function _reportObjectiveStatus() {
		var sObjID = this.getFirstObjectiveID(sAssessID);
		if (sObjID != "") {
		  var objObjective = new CObjective(sObjID);
		  objObjective.reportObjectiveStatus();
		}
	}
	
	//-------------------------------------------------//
	
}		// class