﻿function JSTree(id,targetwindow){
	this.id						= id;
	this.totalItems				= _getTotalItems;
	this.children				= new Array();
	this.appendChild			= _appendChild;
	this.includeRoot			= false;
	this.collapseTree			= _collapseTree;
	this.expandTree				= _expandTree;
	this.toggleExpandBranch		= _toggleExpandBranch;
	this.toggleBranch			= _toggleBranch;
	this.expandBranch			= _expandBranch;
	this.collapseBranch			= _collapseBranch;
	this.openBranch				= _openBranch;
	this.closeBranch			= _closeBranch;
	this.drawTree				= _drawTree;
	this.drawSubTree			= _drawSubTree;
	this.getTreeItem			= _getTreeItem;
	this.refreshTree			= _refreshTree;
	this.targetwindow			= targetwindow;
	this.nodeClick				= _nodeClick;
	this.nodeClickFunc			= null;
	this.setNodeClickFunc		= _setNodeClickFunc;
	this.expandTreeToID			= _expandTreeToID;
	this.collapseSiblings		= true;
	this.setCollapseSiblings	= _setCollapseSiblings;
	this.setOnMouseOverFunc		= _setOnMouseOverFunc;
	this.nodeOnMouseOver		= _nodeOnMouseOver;
	this.nodeOnMouseOverFunc	= null;
	this.setOnMouseOutFunc		= _setOnMouseOutFunc;
	this.nodeOnMouseOut			= _nodeOnMouseOut;
	this.nodeOnMouseOutFunc		= null;
	
	
	
	var oFoundNode;
			
	function _setNodeClickFunc(sFunc){
		this.nodeClickFunc = sFunc;
	}
	
	function _setOnMouseOverFunc(sFunc){
		this.nodeOnMouseOverFunc = sFunc;
	}
	
	function _setOnMouseOutFunc(sFunc){
		this.nodeOnMouseOutFunc = sFunc;
	}	
	
	function _setHiliteFunc(sFunc){
		this.nodeHiliteFunc = sFunc;
	}	
	
	function _appendChild(oTreeItem){
		this.children[this.children.length] = oTreeItem;
	}	
	
	function _getTotalItems(iCnt){
		if (iCnt == null){iCnt = 0;}
		for (var i = 0;i<this.children.length;i++){
			iCnt++;
			if (this.children.children.length > 0){
				this.getTotalItems(iCnt);	
			}	
		}
		return iCnt;	
	}	
		
	function _collapseTree(){
	    try{
		    //make all spans display = "none" except the root nodes
		    var allSpans = this.targetwindow.document.getElementsByTagName("span");
		    for (var i=0;i<allSpans.length;i++){
			    if (allSpans[i].id.substring(0,7) == "branch_"){
				    setCollapsed(this.getTreeItem(this.children[0],allSpans[i].id.substring(7)));
			    }	
		    }
		    this.refreshTree();
		}catch(err){
		}    
	}
	
	function setCollapsed(oNode){
		oNode.setExpanded(false);
		if (oNode.expandIconObj != null){
			oNode.expandIconObj.setState("collapsed");
		}
		if (oNode.nodeIconObj != null){	
			oNode.nodeIconObj.setState("closed");
		}	
	}	
	
	function setExpanded(oNode){
		oNode.setExpanded(true);
		if (oNode.expandIconObj != null){
			oNode.expandIconObj.setState("expanded");
		}
		if (oNode.nodeIconObj != null){		
			oNode.nodeIconObj.setState("open");
		}	
	}
	
	function _expandTree(){
	    try{
		    var allSpans = this.targetwindow.document.getElementsByTagName("span");
		    for (var i=0;i<allSpans.length;i++){
			    if (allSpans[i].id.substring(0,7) == "branch_"){
				    setExpanded(this.getTreeItem(this.children[0],allSpans[i].id.substring(7)));
			    }	
		    }
		    this.refreshTree();	
		}catch(err){
		}
	}
	
	
	function _toggleExpandBranch(id){
		var oNode = this.getTreeItem(this.children[0],id);		
		if (oNode.isExpanded == true){
			this.collapseBranch(oNode);
		}else{
			this.expandBranch(oNode);
		}	
	}
	
	function _expandTreeToID(id){
		var oNode = this.getTreeItem(this.children[0],id);
		if (oNode != null){
			expandTreeToNode(oNode,this);
		}	
	}
	
	function expandTreeToNode(oNode,oTreeObj){
		if (oNode.hasChildren()){
			oTreeObj.openBranch(oNode);
		}else{
			refreshBranch(oNode,oTreeObj);
		}			
		if (oNode.parentNode != null){
			expandTreeToNode(oNode.parentNode,oTreeObj);
		}
	}
	
	
	function _expandBranch(oNode,bRefreshAll){
		oNode.setExpanded(true);
		if (oNode.isVisible == true){	
			if (oNode.expandIconObj != null){		
				oNode.expandIconObj.setState("expanded");
			}	
			if (oNode.hasChildren()){
				if (oNode.nodeIconObj != null){
					oNode.nodeIconObj.setState("open");
				}	
			}	
		}
		if (bRefreshAll == true){
			refreshSiblingsAndParent(oNode,this);
		}else{
			refreshBranch(oNode,this);
		}	
	}
	
	function _collapseBranch(oNode){
		oNode.setExpanded(false);
		if (oNode.expandIconObj != null){
			oNode.expandIconObj.setState("collapsed");
		}
		if (oNode.nodeIconObj != null){	
			oNode.nodeIconObj.setState("closed");
		}	
		refreshSiblingsAndParent(oNode,this);
	}

	function _toggleBranch(id){
		var oNode = this.getTreeItem(this.children[0],id);		
		if (oNode.isExpanded == true){
			this.closeBranch(oNode);
		}else{
			this.openBranch(oNode);
		}	
	}
	
	function _openBranch(oNode){
		collapseSiblings(oNode,true,this);
		this.expandBranch(oNode,false);
	}	
	function _closeBranch(oNode){
		this.collapseBranch(oNode);
	}
	function _drawTree(){
		if (this.children[0] == null){
			return "[Tree has no children]";
		}	
		if (this.includeRoot == true){
			return this.children[0].getTreeHTML();
		}else{
			var sHTML="";
			this.children[0].setVisibility(false);
			for (var i=0;i<this.children[0].children.length;i++){
				sHTML = sHTML + this.children[0].children[i].getTreeHTML();
			}
			return sHTML;	
		}			
	}
	function _drawSubTree(sID){
		var sHTML="";
		var oNode = this.getTreeItem(this.children[0],sID);
		if (oNode == null){
			alert("Node not found: " + sID);
			return null;	
		}		
		if (this.includeRoot == true){
			return oNode.getTreeHTML();
		}else{
			oNode.setVisibility(false);
			
			for (var i=0;i<oNode.children.length;i++){
				sHTML = sHTML + oNode.children[i].getTreeHTML();
			}
			return sHTML;	
		}
	}
	function _getTreeItem(oNode,sID){
		oFoundNode = null;
		findTreeItem(oNode,sID);
		if (oFoundNode == null){
			//alert("Cannot find: " + sID);
		}else{
			return oFoundNode;
		}
	}	
	
	function findTreeItem(oNode,sID){
		if (oFoundNode != null){
			return;
		}	
		if (oNode.id == sID){
			oFoundNode = oNode;
		}	
		if (oNode.hasChildren()){
			for (var i=0;i<oNode.children.length;i++){
				findTreeItem(oNode.children[i],sID);
				if (oFoundNode != null){
					return;
				}	
			}	
		}
	}
	
	function refreshBranch(oNode,treeObj){
	    try{
		    if (oNode.isVisible == true){	
			    if (oNode.isExpanded == true){
				    if (treeObj.targetwindow.document.getElementById("branch_" + oNode.id) != null){					
					    treeObj.targetwindow.document.getElementById("branch_" + oNode.id).style.display = "block";
				    }	
			    }else{
				    if (treeObj.targetwindow.document.getElementById("branch_" + oNode.id) != null){					
					    treeObj.targetwindow.document.getElementById("branch_" + oNode.id).style.display = "none";
				    }	
			    }
			    if (treeObj.targetwindow.document.getElementById("imgExpand_" + oNode.id) !=null){
				    treeObj.targetwindow.document.getElementById("imgExpand_" + oNode.id).src=oNode.expandIconObj.getCurrentStateIcon();
			    }	
			    if (treeObj.targetwindow.document.getElementById("imgFolder_" + oNode.id) != null){
				    treeObj.targetwindow.document.getElementById("imgFolder_" + oNode.id).src=oNode.nodeIconObj.getCurrentStateIcon();
			    }
			    if (treeObj.targetwindow.document.getElementById("imgCompletion_" + oNode.id) != null){
				    treeObj.targetwindow.document.getElementById("imgCompletion_" + oNode.id).src=oNode.completionIconObj.getCurrentStateIcon();
			    }	
		    }
	    }catch(err){
	    }	    
	}	
	
	
	function _refreshTree(){
		refreshEntireTree(this.children[0],this);
	}	
	
	function collapseSiblings(oNode,bRefresh,treeObj){
		if (treeObj.collapseSiblings == true){
			if (oNode.parentNode != null){
				for (var i=0;i<oNode.parentNode.children.length;i++){
					oNode.parentNode.children[i].setExpanded(false);
					if (oNode.parentNode.children[i].expandIconObj != null){
						oNode.parentNode.children[i].expandIconObj.setState("collapsed");
					}
					if (oNode.parentNode.children[i].nodeIconObj != null){	
						oNode.parentNode.children[i].nodeIconObj.setState("closed");
					}	
				}
				if (bRefresh == true){		
					refreshSiblingsAndParent(oNode,treeObj);
				}	
			}	
		}			
	}	
	
	function refreshSiblingsAndParent(oNode,treeObj){
		if (oNode.parentNode == null){
			refreshBranch(oNode,treeObj);
		 	return;
		}
		for (var i=0;i<oNode.parentNode.children.length;i++){
			refreshBranch(oNode.parentNode.children[i],treeObj);
		}		
		var oParent = oNode.parentNode;
		refreshBranch(oParent,treeObj);
		while (oParent.parentNode != null){
			oParent = oParent.parentNode;
			refreshBranch(oParent,treeObj);
		}	
	}	
	
	function refreshEntireTree(oNode,treeObj){			
		refreshBranch(oNode,treeObj);
		for (var i=0;i<oNode.children.length;i++){
			refreshEntireTree(oNode.children[i],treeObj);
		}	
	}
	
	function _nodeClick(sID){
		if (this.nodeClickFunc!=null){
			this.nodeClickFunc(this.getTreeItem(this.children[0],sID));
		}
	}	
	function _nodeOnMouseOver(oRow){
		if (this.nodeOnMouseOverFunc!=null){
			this.nodeOnMouseOverFunc(oRow);
		}
	}
	function _nodeOnMouseOut(oRow){
		if (this.nodeOnMouseOutFunc!=null){
			this.nodeOnMouseOutFunc(oRow);
		}
	}
	function _nodeHilite(oRow){
		if (this.nodeHiliteFunc!=null){
			this.nodeHiliteFunc(oRow);
		}
	}
	
	function _setCollapseSiblings(bVal){
		this.collapseSiblings = bVal;
	}	
	
			
}	

function TreeItem(id,parentNode,sTreeName) {
  this.id						= id;
  this.children					= new Array();
  this.hasChildren				= _hasChildren;
  this.parentNode				= parentNode;
  this.level					= 1;
  this.isExpanded				= false;
  this.isVisible				= true;
  this.nodeItemObj				= "";
  this.nodeText					= "";
  this.borderStyle				= "";
  this.width					= "";
  this.nodeIconObj				= null;
  this.expandIconObj			= null;
  this.completionIconObj		= null;	
  this.data						= "";
  this.nodeIndent				= "15px";	
  this.completionStatus			= "";		
  this.treeName					= sTreeName;
  this.setExpanded				= _setExpanded;
  this.setVisibility			= _setVisibility;
  this.setText					= _setText;
  this.appendChild 				= _appendChild;
  this.getPrevious				= _getPrevious;
  this.getNext					= _getNext;
  this.setNodeItemObj			= _setNodeItemObj;
  this.setNodeItemObjOrder		= _setNodeItemObjOrder;
  this.setNodeIcon				= _setNodeIcon;
  this.setNodeIconOrder			= _setNodeIconOrder;
  this.setExpandIcon			= _setExpandIcon;
  this.setExpandIconOrder		= _setExpandIconOrder;
  this.setCompletionIcon		= _setCompletionIcon;
  this.setCompletionIconOrder	= _setCompletionIconOrder;
  this.setData					= _setData;
  this.setBorderStyle			= _setBorderStyle;
  this.setWidth					= _setWidth;
  this.setIndent				= _setIndent;
  this.getTreeHTML				= _getTreeHTML;
  this.setCompletionStatus		= _setCompletionStatus;
  this.setLevel					= _setLevel;
  
	function _setText(sText){
		this.nodeText = sText;
	}  
  	
  	function _appendChild(oTreeItem, nIndex){
  		if (nIndex != null){
  			var tempArray = new Array();
  			tempArray = this.children;
  			this.children = new Array();
  			for (var i=0;i<this.tempArray.length+1;i++){
  				if (i == nIndex){
  					this.children[i] = oTreeItem;
  				}else{
  					this.children[i] = tempArray[i];
  				}	
  			}	
  		}else{
  			this.children[this.children.length] = oTreeItem;
  		}	
	}
	
	function _setLevel(sLevel){
		this.level = sLevel;
	}	
	
	function _getNext(){
		for (var i=0;i<this.parentNode.children.length;i++){
			if (this.parentNode.children.length == (i-1)){
  				return null;
  			}else if (this.parentNode.children[i].id == this.id){
  				return this.parentNode.children[i+1];
   			}	
  					
  		}	
		return null;
	}
  	
  	function _getPrevious(){
		for (var i=0;i<this.parentNode.children.length;i++){
			if (this.parentNode.children.length == (i-1)){
				return null;
			}else if (this.parentNode.children[i].id == this.id){
				return this.parentNode.children[i-1];
   			}	
  		}	
  		return null;
	}
	function _setNodeItemObj(oObj){
		this.nodeItemObj = oObj;
	}
	function _setNodeItemObjOrder(nOrder){
		this.nodeItemObj.order = nOrder;
	}
	function _setNodeIcon(oImg){
		this.nodeIconObj = oImg;
	}
	function _setNodeIconOrder(oOrder){
		this.nodeIconObj.order = oOrder;
	}
	function _setExpandIcon(oImg){
		this.expandIconObj = oImg;
	}
	function _setExpandIconOrder(oOrder){
		this.expandIconObj.order = oOrder;
	}
	function _setCompletionIcon(oImg){
		this.completionIconObj = oImg;
	}
	function _setCompletionIconOrder(oOrder){
		this.completionIconObj.order = oOrder;
	}
	function _setBorderStyle(sStyle){
		this.borderStyle = sStyle;
	}
	function _setWidth(sWidth){
		if (sWidth != "" && sWidth != null && sWidth != "null"){
			this.width = "width: " + sWidth + ";";
		}	
	}	
	function _setIndent(sIndent){
		this.nodeIndent = sIndent;
	}
	function _setExpanded(bVal){
		this.isExpanded = bVal;
	}	
	function _setVisibility(bVal){
		this.isVisible = bVal;
	}
	function _setData(data){
		this.data = data;
	}	
	function _getTreeHTML(){
		var sHTML = "";
		var sDisplay = "";
		if (this.isVisible == true){
			if (this.nodeItemObj.image != ""){
				sDisplay = "<div style='margin-left: 0px; padding-left: " + this.nodeItemObj.captionPadLeft +"; padding-right: " + this.nodeItemObj.captionPadRight +"; padding-top: " + this.nodeItemObj.captionPadTop +"; padding-bottom: " + this.nodeItemObj.captionPadBottom +"; cursor: pointer; " + this.nodeItemObj.itemHeight +" " + this.nodeItemObj.itemWidth + " text-align: " + this.nodeItemObj.captionAlign +"; background-repeat: no-repeat; background-image: url(" + this.nodeItemObj.image + ")'>" + this.nodeItemObj.text + "</div>"; 
			}else{
				sDisplay = "<div style='padding-left: " + this.nodeItemObj.captionPadLeft +"; padding-left: " + this.nodeItemObj.captionPadRight +"; padding-left: " + this.nodeItemObj.captionPadTop +"; padding-left: " + this.nodeItemObj.captionPadBottom +"; cursor: pointer; " + this.nodeItemObj.itemHeight +" " + this.nodeItemObj.itemWidth + " text-align: " + this.nodeItemObj.captionAlign +";'>" + this.nodeItemObj.text + "</div>"; 
			}	
			sHTML = sHTML + "\n<div style='clear: both;'><div id='Row_" + this.id + "' style='float: left;" +  this.width + "' class='" + this.borderStyle + "' ";
			if (eval(this.treeName + ".nodeOnMouseOver") != null){
				sHTML = sHTML + "onmouseover='" + this.treeName + ".nodeOnMouseOver(this);return false;' "; 
			}	
			if (eval(this.treeName + ".nodeOnMouseOut") != null){
				sHTML = sHTML + "onmouseout='" + this.treeName + ".nodeOnMouseOut(this);return false;' "; 
			}
			sHTML = sHTML + ">";	
			
			for (var i = 1;i<=4;i++){

				//Completion Icon
				if (this.completionIconObj != null){
					if (this.completionIconObj.order == i || this.completionIconObj.order == null){
						sHTML = sHTML + "<div style='margin-right: 0px; float: left;' class='" + this.completionIconObj.borderStyle + "'><img src='" + this.completionIconObj.getCurrentStateIcon() + "' id='imgCompletion_" + this.id +"' /></div>";
					}
				}	
				// Expand Icon
				if (this.expandIconObj != null){
					if (this.expandIconObj.order == i || this.expandIconObj.order == null){
						if (this.hasChildren()){
							sHTML = sHTML + "<div style='float: left; cursor: hand;' class='" + this.expandIconObj.borderStyle + "'><a href='javascript:void(0)' onclick='" + this.treeName + ".toggleExpandBranch(\"" + this.id  + "\");return false;'><img border='0' id='imgExpand_" + this.id +"' src='" + this.expandIconObj.getCurrentStateIcon() + "' /></a></div>";
						}				
					}
				}
				// NodeIcon	
				if (this.nodeIconObj != null){
					if (this.nodeIconObj.order == i || this.nodeIconObj.order == null){
						if (this.hasChildren()){
							if (this.nodeIconObj != null){
								sHTML = sHTML + "<div style='float: left; cursor: hand;' class='" + this.nodeIconObj.borderStyle + "'><a href='javascript:void(0)' onclick='" + this.treeName + ".toggleBranch(\"" + this.id  + "\");" + this.treeName + ".nodeClick(\"" + this.id + "\");return false;'><img border='0' id='imgFolder_" + this.id +"' src='" + this.nodeIconObj.getCurrentStateIcon() + "'/></a></div>";
							}
						}else{
							if (this.nodeIconObj != null){
								if (this.nodeIconObj.openIcon != null){
									sHTML = sHTML + "<div style='float: left; cursor: hand;' class='" + this.nodeIconObj.borderStyle + "'><a style='text-decoration:none' href='javascript:void(0)' onclick='" + this.treeName + ".nodeClick(\"" + this.id + "\");return false;'><img border='0' id='imgFolder_" + this.id +"' src='" + this.nodeIconObj.getCurrentStateIcon() + "' /></a></div>";
								}else{
									sHTML = sHTML + "<div style='float: left; cursor: hand;' class='" + this.nodeIconObj.borderStyle + "'><a style='text-decoration:none' href='javascript:void(0)' onclick='" + this.treeName + ".nodeClick(\"" + this.id + "\");return false;'><img border='0' id='imgEvent_" + this.id +"' src='" + this.nodeIconObj.getCurrentStateIcon() + "'/></a></div>";
								}	
							}
						}
					}
				}				
				// Node Item
				if (this.nodeItemObj!=null){
					if (this.nodeItemObj.order == i || this.nodeItemObj.order == null){
						if (this.hasChildren()){
							sHTML = sHTML + "<a href='javascript:void(0)' style='float: left; text-decoration:none' onclick='" + this.treeName + ".toggleBranch(\"" + this.id  + "\");" + this.treeName + ".nodeClick(\"" + this.id + "\");return false;'><div id='Text_" + this.id + "' class='" + this.nodeItemObj.fontStyle + " " + this.nodeItemObj.borderStyle + "'>" + sDisplay + "</div></a>";
						}else{
							sHTML = sHTML + "<a style='float: left; text-decoration:none' href='javascript:void(0)' onclick='" + this.treeName + ".nodeClick(\"" + this.id + "\");return false;'><div id='Text_" + this.id + "' class='" + this.nodeItemObj.fontStyle + " " + this.nodeItemObj.borderStyle + "'>" + sDisplay + "</div></a>";
						}	
					}
				}					
			}		
			sHTML = sHTML + "</div></div>"
		}	
		if (this.hasChildren()){
			if (this.isVisible == true){
				if (this.isExpanded == true){
					sHTML = sHTML + "<span id='branch_" + this.id +"' style='display:block; cursor: pointer; margin-left:" + this.nodeIndent + ";' name='branch'>";
				}else{
					sHTML = sHTML + "<span id='branch_" + this.id +"' style='display:none; cursor: pointer; margin-left:" + this.nodeIndent + ";' name='branch'>";
				}	
			}	
			for (var i=0;i<this.children.length;i++){
				sHTML = sHTML + this.children[i].getTreeHTML();
			}
			if (this.isVisible == true){	
				sHTML = sHTML + "</span>";
			}	
		}
		return sHTML;		

	}
	function _setCompletionStatus(sStatus){
		this.completionStatus = sStatus;
		if (this.completionIconObj != null){
			this.completionIconObj.setState(sStatus);
		}	
	}	
	function _hasChildren(){
		if (this.children.length > 0){
			return true;
		}	
		return false;
	}	
	
} 


function ExpandIcon(){
	this.borderStyle			= "";	
	this.currentState			= "collapsed";
	this.expandedIcon			= "";
	this.collapsedIcon			= "";
	this.setState				= _setState;
	this.getState				= _getState;
	this.setExpandedIcon		= _setExpandedIcon;
	this.setCollapsedIcon		= _setCollapsedIcon;
	this.getCurrentStateIcon	= _getCurrentStateIcon;
	this.getCurrentStateHTML	= _getCurrentStateHTML;
	this.setBorderStyle			= _setBorderStyle;
	
	function _setState(sState){
		if (sState == "collapsed" || sState == "expanded"){
			this.currentState = sState;
		}	
	}
	
	function _getState(){
		return this.currentState;
	}
	
	function _setExpandedIcon(sImgPath){
		this.expandedIcon = sImgPath;
	}
	
	function _setCollapsedIcon(sImgPath){
		this.collapsedIcon = sImgPath;
	}
	
	function _getCurrentStateIcon(){
		if (this.currentState == "expanded"){
			return this.expandedIcon;	
		}else if (this.currentState == "collapsed"){
			return this.collapsedIcon;	
		}	
	}
	function _getCurrentStateHTML(){
		var sIcon = "";
		if (this.currentState == "expanded"){
			sIcon = this.expandedIcon;	
		}else if (this.currentState == "collapsed"){
			sIcon = this.collapsedIcon;	
		}	
		return "<img src='" + sIcon + "'/>";
	}
	function _setBorderStyle(sStyleName){
		this.borderStyle = sStyleName;
	}
} 

function FolderIcon(){
	this.borderStyle			= "";	
	this.currentState			= "closed";
	this.openIcon				= "";
	this.closedIcon				= "";
	this.setState				= _setState;
	this.getState				= _getState;
	this.setOpenIcon			= _setOpenIcon;
	this.setClosedIcon			= _setClosedIcon;
	this.getCurrentStateIcon	= _getCurrentStateIcon;
	this.getCurrentStateHTML	= _getCurrentStateHTML;
	this.setBorderStyle			= _setBorderStyle;
	
	function _setState(sState){
		if (sState == "closed" || sState == "open"){
			this.currentState = sState;
		}	
	}
	
	function _getState(){
		return this.currentState;
	}
	
	function _setOpenIcon(sImgPath){
		this.openIcon = sImgPath;
	}
	
	function _setClosedIcon(sImgPath){
		this.closedIcon = sImgPath;
	}
	
	function _getCurrentStateIcon(){
		if (this.currentState == "open"){
			return this.openIcon;	
		}else if (this.currentState == "closed"){
			return this.closedIcon;	
		}	
	}
	function _getCurrentStateHTML(){
		var sIcon = "";
		if (this.currentState == "open"){
			sIcon = this.openIcon;	
		}else if (this.currentState == "closed"){
			sIcon = this.closedIcon;	
		}	
		return "<img src='" + sIcon + "'/>";
	}
	function _setBorderStyle(sStyleName){
		this.borderStyle = sStyleName;
	}
} 

function EventIcon(){
	this.borderStyle			= "";	
	this.currentState			= "state1";
	this.state1Icon				= "";
	this.state2Icon				= "";
	this.state3Icon				= "";
	this.setState				= _setState;
	this.getState				= _getState;
	this.setState1Icon			= _setState1Icon;
	this.setState2Icon			= _setState2Icon;
	this.setState3Icon			= _setState3Icon;
	this.getCurrentStateIcon	= _getCurrentStateIcon;
	this.getCurrentStateHTML	= _getCurrentStateHTML;
	this.setBorderStyle			= _setBorderStyle;
	
	function _setState(sState){
		if (sState == "state1" || sState == "state2" || sState == "state3"){
			this.currentState = sState;
		}	
	}
	
	function _getState(){
		return this.currentState;
	}
	
	function _setState1Icon(sImgPath){
		this.state1Icon = sImgPath;
	}
	function _setState2Icon(sImgPath){
		this.state2Icon = sImgPath;
	}
	function _setState3Icon(sImgPath){
		this.state3Icon = sImgPath;
	}
	function _getCurrentStateIcon(){
		if (this.currentState == "state1"){
			return this.state1Icon;	
		}else if (this.currentState == "state2"){
			return this.state2Icon;	
		}else if (this.currentState == "state3"){
			return this.state3Icon;	
		}		
	}
	function _getCurrentStateHTML(){
		var sIcon = "";
		if (this.currentState == "state1"){
			sIcon = this.state1Icon;	
		}else if (this.currentState == "state2"){
			sIcon = this.state2Icon;	
		}else if (this.currentState == "state3"){
			sIcon = this.state3Icon;	
		}		
		return "<img src='" + sIcon + "'/>";
	}
	function _setBorderStyle(sStyleName){
		this.borderStyle = sStyleName;
	}
	
} 


function CompletionIcon(){
	this.borderStyle			= "";	
	this.currentState			= "n";
	this.notStartedIcon			= "";
	this.startedIcon			= "";
	this.completedIcon			= "";
	this.setState				= _setState;
	this.getState				= _getState;
	this.setNotStartedIcon		= _setNotStartedIcon;
	this.setStartedIcon			= _setStartedIcon;
	this.setCompletedIcon		= _setCompletedIcon;
	this.getCurrentStateIcon	= _getCurrentStateIcon;
	this.getCurrentStateHTML	= _getCurrentStateHTML;
	this.setBorderStyle			= _setBorderStyle;
	
	function _setState(sState){
		this.currentState = sState;
	}
	
	function _getState(){
		return this.currentState;
	}
	
	function _setNotStartedIcon(sImgPath){
		this.notStartedIcon = sImgPath;
	}
	function _setStartedIcon(sImgPath){
		this.startedIcon = sImgPath;
	}
	function _setCompletedIcon(sImgPath){
		this.completedIcon = sImgPath;
	}
	function _getCurrentStateIcon(){
		if (this.currentState == "n"){
			return this.notStartedIcon;	
		}else if (this.currentState == "i"){
			return this.startedIcon;	
		}else if (this.currentState == "c"){
			return this.completedIcon;	
		}		
	}
	function _getCurrentStateHTML(){
		var sIcon = "";
		if (this.currentState == "n"){
			sIcon = this.notStartedIcon;	
		}else if (this.currentState == "i"){
			sIcon = this.startedIcon;	
		}else if (this.currentState == "c"){
			sIcon = this.completedIcon;	
		}		
		return "<img src='" + sIcon + "'/>";
	}
	function _setBorderStyle(sStyleName){
		this.borderStyle = sStyleName;
	}
} 

function NodeItemObj(){
	this.borderStyle			= "";
	this.fontStyle				= "";
	this.image					= "";
	this.text					= "";
	this.itemWidth				= "";
	this.itemHeight				= "";
	this.captionAlign			= "left";
	this.captionPadLeft			= "0px";
	this.captionPadRight		= "0px";
	this.captionPadTop			= "0px";
	this.captionPadBottom		= "0px";
	this.setBorderStyle			= _setBorderStyle;
	this.setFontStyle			= _setFontStyle;
	this.setImage				= _setImage;
	this.setCaptionAlign		= _setCaptionAlign;
	this.setCaptionPadding		= _setCaptionPadding;
	this.setText				= _setText;
	this.setItemWidth			= _setItemWidth;
	this.setItemHeight			= _setItemHeight;
	
	function _setText(sText){
		this.text = sText;
	}	
	
	function _setItemWidth(sWidth){
		if (sWidth.toLowerCase().indexOf("width") == -1){
			this.itemWidth = "width:" + sWidth + ";";
		}else{
			this.itemWidth = sWidth;
		}	
	}	
	
	function _setItemHeight(sHeight){
		if (sHeight.toLowerCase().indexOf("height") == -1){
			this.itemHeight = "height:" + sHeight + ";";
		}else{
			this.itemHeight = sHeight;
		}	
	}
	
	function _setBorderStyle(sStyleName){
		this.borderStyle = sStyleName;
	}	
	
	function _setFontStyle(sStyleName){
		this.fontStyle = sStyleName;
	}	
	
	function _setImage(sImgPath){
		this.image = sImgPath;
	}
		
	function _setCaptionAlign(sAlign){
		if (sAlign.toLowerCase() == "left" || sAlign.toLowerCase() == "center" || sAlign.toLowerCase() == "right"){
			this.captionAlign = sAlign;
		}	
	}	
	
	function _setCaptionPadding(sLeft,sRight,sTop,sBottom){
		this.captionPadLeft = sLeft;
		this.captionPadRight = sRight;
		this.captionPadTop = sTop;
		this.captionPadBottom = sBottom;
	}	
	
} 