﻿function CMultistateImage(sMSIObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.msiObject										=	sMSIObject;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}


	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.msiObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	
	if(this.windowTarget.arrContent[this.msiObject] != null) {
		this.defaultState									=	this.windowTarget.arrContent[this.msiObject].DEFAULTSTATE;
	}

	//-------------method declaration-----------------//
	this.getMSIDefaultState						=	_getMSIDefaultState;
	this.setMultistateImage						=	_setMultistateImage;
	this.getMultistateImage						=	_getMultistateImage;
	this.setMultistateImageState			=	_setMultistateImageState;	
	this.getMultistateImageState			=	_getMultistateImageState;
	
	
	//------------methods from class inheritance-----------//	
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };
	
	//-------------method definition-----------------//
	function initialize() {
		if(sMSIObject == '[object]') {
			sMSIObject =	new CFrameObject(sMSIObject).getCurrentFrameObjectName();
		}
	}
		
	function _getMSIDefaultState() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.msiObject);
		}		
		
		return this.defaultState;
	}
	
	
	function _getMultistateImage(sState) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.msiObject);
		}		
		
		if (sState.toLowerCase() == "state 1") {
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.msiObject].STATE1;
		} else if (sState.toLowerCase() == "state 2")	{
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.msiObject].STATE2;
		} else if (sState.toLowerCase() == "state 3")	{
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.msiObject].STATE3;
		} else if (sState.toLowerCase() == "state 4")	{
			return m_sContentDir + "/" + this.windowTarget.arrContent[this.msiObject].STATE4;
		}
	}
	
	
	function _setMultistateImage(sState,sSrc) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.msiObject);
		}		
		
		sState = sState.toLowerCase();
	
		if (sState == "state 1") {	
			this.windowTarget.arrContent[this.msiObject].STATE1 = sSrc;
		} else if (sState == "state 2") {
			this.windowTarget.arrContent[this.msiObject].STATE2 = sSrc;
		} else if (sState == "state 3") {
			this.windowTarget.arrContent[this.msiObject].STATE3 = sSrc;
		} else if (sState == "state 4") {
			this.windowTarget.arrContent[this.msiObject].STATE4 = sSrc;
		}	
		
		// If a current state exists
		if (this.windowTarget.arrContent[this.msiObject].CURRENTSTATE != null) {
			if (this.windowTarget.arrContent[this.msiObject].CURRENTSTATE.toLowerCase() == "" && sState == "state 1") {
				var obj = this.windowTarget.document.getElementById("div_" + this.msiObject);
				if (obj != null) {
					obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			} else if (this.windowTarget.arrContent[this.msiObject].CURRENTSTATE.toLowerCase() == sState) {
				var obj = this.windowTarget.document.getElementById("div_" + this.msiObject);
				if (obj != null) {
					obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			}
		} else {
			if (this.windowTarget.arrContent[this.msiObject].DEFAULTSTATE != null) {
				if (this.windowTarget.arrContent[this.msiObject].DEFAULTSTATE.toLowerCase() == sState) {
					var obj = this.windowTarget.document.getElementById("div_" + this.msiObject);
					if (obj != null) {
						obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
					}	
				}
			} else if (sState == "state 1") {
				var obj = this.windowTarget.document.getElementById("div_" + this.msiObject);
				if (obj != null) {
					obj.firstChild.src = m_sContentDir + "/media/" + sSrc;
				}	
			}
		}
	}
	

	function _setMultistateImageState(sState) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.msiObject);
		}		
		
		if (this.windowTarget.document.images['msi_' + this.msiObject] == null) {
			return;
		}
		var sMediaPath = m_sContentDir + "/media/";
		if (String(sState).toLowerCase() == "state 1") {
			this.windowTarget.document.images['msi_' + this.msiObject].src = sMediaPath + this.windowTarget.arrContent[this.msiObject].STATE1;
		} else if (String(sState).toLowerCase() == "state 2") {
			this.windowTarget.document.images['msi_' + this.msiObject].src = sMediaPath + this.windowTarget.arrContent[this.msiObject].STATE2;
		} else if (String(sState).toLowerCase() == "state 3") {
			this.windowTarget.document.images['msi_' + this.msiObject].src = sMediaPath + this.windowTarget.arrContent[this.msiObject].STATE3;
		} else if (String(sState).toLowerCase() == "state 4") {
			this.windowTarget.document.images['msi_' + this.msiObject].src = sMediaPath + this.windowTarget.arrContent[this.msiObject].STATE4; 
		}	
		this.windowTarget.arrContent[this.msiObject].CURRENTSTATE=sState.toLowerCase();
	}
	
	
	function _getMultistateImageState() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.msiObject);
		}		
		
		if (convertNull(this.windowTarget.arrContent[this.msiObject].CURRENTSTATE) == "") {
			return this.windowTarget.arrContent[this.msiObject].DEFAULTSTATE;
		}	
		return this.windowTarget.arrContent[this.msiObject].CURRENTSTATE;
	}	


	//--------------------------------------------------------//
	
}			// class