﻿function CObjective(sObjectiveID) {
	//------------property declaration-------------//
	this.objID													=	sObjectiveID;

	
	//----------validate the objective before setting properties----------//
	this.isObjectiveExists							=	_isObjectiveExists;
	
	if(sObjectiveID != null && m_arrObjectives[this.objID] != null && this.isObjectiveExists() == true) {	
		this.description									=	m_arrObjectives[this.objID].DESCRIPTION;
		this.met													=	m_arrObjectives[this.objID].MET;
		this.assessments									=	m_arrObjectives[this.objID].ASSESSMENTS;
		this.events												=	m_arrObjectives[this.objID].EVENTS;
	}


	//------------method declaration-------------//
	this.getDescription									=	_getDescription;
	this.getObjectiveMet								=	_getObjectiveMet;
	this.getAssessments									=	_getAssessments;
	this.getAssessmentTokens						=	_getAssessmentTokens;
	this.getEvents											=	_getEvents;
	this.getEventTokens									=	_getEventTokens;

	this.getOverallObjective							=	_getOverallObjective;	
	this.getAllSubObjectivesNames					=	_getAllSubObjectivesNames;
	this.getAllSubObjectivesDesc					= _getAllSubObjectivesDesc;
	this.getAllSubObjectivesNameAndDesc		=	_getAllSubObjectivesNameAndDesc;
	this.getAllSubObjectivesNameAndMet		=	_getAllSubObjectivesNameAndMet;
	this.getAllSubObjectivesNameDescMet		=	_getAllSubObjectivesNameDescMet;
	
	this.getStatusForObjective					=	_getStatusForObjective;
	this.getStatusForObjectiveVisited		=	_getStatusForObjectiveVisited;
	this.getStatusForObjectiveScored		=	_getStatusForObjectiveScored;
	this.reportObjectiveStatus					=	_reportObjectiveStatus;


	//------------method definition-------------//
	function _isObjectiveExists() {		
		for(nObjID in m_arrObjectives) {
			if(nObjID == this.objID) {
				return true;
			}
		}
		return false;
	}	
	
	function _getDescription() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		return this.description;
	}

	function _getObjectiveMet() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		return this.met;
	}

	function _getAssessments() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		var sResult = this.assessments;
		if(sResult == undefined) {
			return "";
		}
		return sResult;
	}
		
	function _getAssessmentTokens() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		var arrResult;
		var str = "";
		str = this.getAssessments();
		str = str.substring(3);
		arrResult = str.split("^,^");
		return arrResult;
	}
	
	function _getEvents() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		var sResult = "";
		for(var i=0; i<this.events.length; i++) {
			sResult  = sResult + "|" + this.events[i];
		}
		sResult = sResult.substring(1);
		return sResult;
	}
	
	function _getEventTokens() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		return this.events;
	}	
	
	
	function _getOverallObjective() {
		return m_sTerminalObjective;	
	}
	
	
	function _getAllSubObjectivesNames() {
		var sReturn = "";
		if (m_arrObjectives == null) {
		  alert("No objectives defined");
		  return;
		}
		for (var i in m_arrObjectives) {
			sReturn = sReturn + "|" + convertNull(m_arrObjectives[i].ID);
		}	
		sReturn = sReturn.substring(1,sReturn.length);
			
		return sReturn;
	}
	
	
	function _getAllSubObjectivesDesc() {
		var sReturn = "";
		if (m_arrObjectives == null){
		  alert("No objectives defined");
		  return;
		}
		for (var i in m_arrObjectives){
			sReturn = sReturn + "|" + convertNull(m_arrObjectives[i].DESCRIPTION);
		}	
		sReturn = sReturn.substring(1,sReturn.length);
		return sReturn;		
	}
	
	
	function _getAllSubObjectivesNameAndDesc() {
		var sReturn = "";
		for (var i in m_arrObjectives){
			sReturn = sReturn + "|" + convertNull(m_arrObjectives[i].ID) + " - " +  convertNull(m_arrObjectives[i].DESCRIPTION);
		}	
		sReturn = sReturn.substring(1,sReturn.length);
		return sReturn;				
	}
	
	function _getAllSubObjectivesNameAndMet() {
		var sReturn = "";
		for (var i in m_arrObjectives){
			sReturn = sReturn + "|" + convertNull(m_arrObjectives[i].ID) + " - " +  convertNull(m_arrObjectives[i].MET);
		}	
		sReturn = sReturn.substring(1,sReturn.length);
		return sReturn;		
	}
	
	function _getAllSubObjectivesNameDescMet() {
		var sReturn = "";
		for (var i in m_arrObjectives){
			sReturn = sReturn + "|" + convertNull(m_arrObjectives[i].ID) + " - " +  convertNull(m_arrObjectives[i].DESCRIPTION) + " - " +  convertNull(m_arrObjectives[i].MET);
		}	
		sReturn = sReturn.substring(1,sReturn.length);
		return sReturn;		
	}
	
		
	function _getStatusForObjective() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		if (m_arrObjectives[this.objID] == null){	
			alert("function getStatusForObjective: The objective '" + this.objID + "' was not found.");
			return;
		}
		var sVisited = "completed";
		var sScore = "passed";
		
		if (String(this.met) == "optVisited"){  
			sVisited = this.getStatusForObjectiveVisited();
			return sVisited;
		}else if (String(this.met) == "optScored"){
			sScore = this.getStatusForObjectiveScored();
			return sScore;
		}else if (String(this.met) == "optBoth"){    
			sVisited = this.getStatusForObjectiveVisited();
			sScore = this.getStatusForObjectiveScored();
			if (sScore == "passed"){
				return sScore;
			}else if (sVisited == "completed"){
				return sVisited;
			}else if(sScore == "failed") {	
				return sScore;
			}else{	
				return sVisited;		
			}	
		}		
	}
	
	
	function _getStatusForObjectiveVisited() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		for (var i=0;i<this.events.length;i++) { 
			var objEvent	=	new CEvent(this.events[i],this.windowTarget);
			if(convertNull(objEvent.visited).toLowerCase() != "true") {
				return "incomplete";  
			}
		}
		return "completed";  		
	}
	
	
	function _getStatusForObjectiveScored() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		var arrAssess = this.getAssessmentTokens();   
		if(arrAssess[0] == '') {
			return this.objID + " property is set to only visited.";
		}
		
		for (var i=0;i<arrAssess.length;i++) {
			var objAssess = new CAssessment(arrAssess[i]);
			if(objAssess.getPassFail(true,false) != "P"){
				return "failed";
			}
		}
		return "passed";		
	}
	
	
	function _reportObjectiveStatus() {
		if(this.isObjectiveExists() == false) {
			if(m_debug == true) {
				alert("Error! " + this.objID + " objective doesn't exists.");
			}
			return null;
		}
		
		if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			if (this.objID != ""){
			  lmsReportObjStatus(this.objID);		
			}
		}			
	}				
	
	//------------------------------------------------//	
}		//class


	//----------------- global ---------------//	
	// the below functions is called from navigation_data.js (by default)//
	function loadAllObjectives() {				
	  for (var i in m_arrEvents){
	    if (m_arrEvents[i].OBJECTIVEID != null) {
	      if (m_arrEvents[i].OBJECTIVEID != ""){
	        oObjectiveID = m_arrEvents[i].OBJECTIVEID;
	        if (oObjectiveID.indexOf("|") != -1){
	          oArrayObjID = oObjectiveID.split("|");
	        }else{
	          oArrayObjID = new Array();
	          oArrayObjID[0] = oObjectiveID;
	        } 
	        for (var j=0;j<oArrayObjID.length;j++){
	          if (m_arrObjectives[oArrayObjID[j]] != null){	
	          	m_arrObjectives[oArrayObjID[j]].EVENTS = arrPush(m_arrObjectives[oArrayObjID[j]].EVENTS, m_arrEvents[i].ID);	
			  }	          	
	        }        
	      }
	    }      
	  }    
	}
