﻿function CVideo(sVideoObject,targetwindow) {
	//-------------property declaration-----------------//
	initialize();
	
	this.videoObject								=	sVideoObject;
	this.parentEngine								= parent.engine;
	
	if(targetwindow == null) {
		this.windowTarget							=	parent.content;
	} else {
		this.windowTarget							=	targetwindow;
	}	
	

	//------------class inheritance and frame object validation----------//
	var objUtil												=	new CUtil();
	var objFrameObject	 							=	new CFrameObject(this.videoObject,this.windowTarget);
	this.isFrameObjectExists					=	objFrameObject.isFrameObjectExists();
	

	if(this.windowTarget.arrContent[this.videoObject] != null) {
		this.filename										=	this.windowTarget.arrContent[this.videoObject].FILENAME;
	}

	//-------------method declaration------------------//
	this.getVideoFilename						=	_getVideoFilename;
	this.setVideoFile								= _setVideoFile;
	this.setVolume									=	_setVolume;
	this.rewind											=	_rewind;


	//-------------method declaration & inheritance from the class CAudio-----------------//
	var objAudio			=	new CAudio(this.videoObject,this.windowTarget);
	
	this.getVideoAltHTML						=	function() {return objAudio.getAudioAltHTML() };
	this.getVideoShowControls				=	function() {return objAudio.getAudioShowControls() };
	this.getVideoAutoStart					=	function() {return objAudio.getAudioAutoStart() };

	// Video controls //
	this.videoPlay									=	function() {return objAudio.audioPlay() };
	this.videoStop									=	function() {return objAudio.audioStop() };
	this.videoPause									=	function() {return objAudio.audioPause() }; 
	this.toggleVideo								=	function() {return objAudio.toggleAudio() };
	
	// new functions
	this.getPlayerVersion						=	function() {return objAudio.getPlayerVersion() };
	this.getVolume									=	function() {return objAudio.getVolume() };
	this.nextTrack									=	function() {return objAudio.nextTrack() };
	this.previousTrack							=	function() {return objAudio.previousTrack() };
	this.volumeDown									=	function() {return objAudio.volumeDown() };
	this.volumeUp										=	function() {return objAudio.volumeUp() };
	this.muteVolume									=	function() {return objAudio.muteVolume() };
	this.forward										= function() {return objAudio.forward() };
	this.fastForward								=	function() {return objAudio.fastForward() };
	this.setNormal									=	function() {return objAudio.setNormal() };
	this.balance										=	function() {return objAudio.balance() };

	//------------methods from inherited class----------//
	this.getVisibility							=	function() 									{return objFrameObject.getVisibility() };
	this.setVisibility							=	function(sState) 						{objFrameObject.setVisibility(sState) };
	this.getObjectZIndex						=	function() 									{return objFrameObject.getObjectZIndex() };
	this.setObjectZIndex						=	function(nZIndex) 					{objFrameObject.setObjectZIndex(nZIndex) };	
	this.moveObject									=	function(x,y) 							{return objFrameObject.moveObject(x,y) };
	this.resizeFrameObject					=	function(x,y,width,height)	{return objFrameObject.resizeFrameObject(x,y,width,height) };
	this.getLayerNameForObject			=	function() 									{return objFrameObject.getLayerNameForObject() };
	this.getPositionAndSize					= function()									{return objFrameObject.getPositionAndSize() };
	
	//-------------method definition-----------------//
	function initialize() {
		if(sVideoObject == '[object]') {
			sVideoObject =	new CFrameObject(sVideoObject).getCurrentFrameObjectName();
		}
	}	
	
	function _getVideoFilename() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.videoObject);
		}		
		
		if(m_sAudioSupport == "wmp64") {
				var sResult = this.windowTarget.document.getElementById(this.videoObject).FileName;
		} else if(m_sAudioSupport == "wmp71") {
				var sResult = this.windowTarget.document.getElementById(this.videoObject).URL;
		}
		this.filename = sResult.replace("\\.\\","\\");
		
		return this.filename;
	}

	function _setVideoFile(sAudPath) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.videoObject);
		}		
				
		if (m_sAudioSupport == "wmp64") {
			if (m_bMultiPubRel) {
				this.filename = m_sMultiCourseDir + "/media/" + sAudPath;
				return this.windowTarget.document.getElementById(this.videoObject).FileName = m_sMultiCourseDir + "/media/" + sAudPath;
			}else{
				this.filename = m_sContentDir + "/media/" + sAudPath;
				return this.windowTarget.document.getElementById(this.videoObject).FileName = m_sContentDir + "/media/" + sAudPath;
			}	
		} else if (m_sAudioSupport == "wmp71") {
			if (m_bMultiPubRel){
				this.filename = CP.m_sMultiCourseDir + "/media/" +  sAudPath;
				return this.windowTarget.document.getElementById(this.videoObject).URL = CP.m_sMultiCourseDir + "/media/" +  sAudPath;
			}else{
				this.filename = m_sContentDir + "/media/" +  sAudPath;
				return this.windowTarget.document.getElementById(this.videoObject).URL = m_sContentDir + "/media/" +  sAudPath;
			}			
		}
	}	
	
	
	function _setVolume(nVal) {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.videoObject);
		}		
				
		if (m_sAudioSupport == "wmp64") {
			// need to add condition for min & max
			this.parentEngine.document.getElementById("AudioPlayer").Volume = nVal;
			this.windowTarget.document.getElementById(this.videoObject).Settings.Volume = nVal;
		} else if (m_sAudioSupport == "wmp71") {
			if(nVal > 90) {
				nVal = 100;
			} else if(nVal < 5) {
				nVal = 0;
			}
			this.parentEngine.document.getElementById("AudioPlayer").settings.volume = nVal;
			this.windowTarget.document.getElementById(this.videoObject).settings.volume = nVal;			
		}
	}
	
	
	function _rewind() {
		if(this.isFrameObjectExists == false) {
			return objUtil.handleError(this.videoObject);
		}		
		
		if (m_sAudioSupport == "wmp64") {
			// need to check
			this.parentEngine.document.getElementById("AudioPlayer").Rate = -2.0;
			this.windowTarget.document.getElementById(this.videoObject).Settings.Rate = -2.0;
		} else if(m_sAudioSupport == "wmp71") {
			this.parentEngine.document.getElementById("AudioPlayer").settings.rate = -2.0;
			this.windowTarget.document.getElementById(this.videoObject).settings.rate = -2.0;			
		}				
	}	

	//--------------------------------------------------------//
	
}			// class